<?php

namespace app\components;

use app\models\Param;
use Yii;
use yii\base\Component;
use yii\base\InvalidConfig\Exception;
use yii\helpers\ArrayHelper;

/**
 * ClientSiesa.php
 *
 * PHP Version 5.3.0
 *
 * @category category
 * @package package
 * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2017 INGENEO S.A.S.
 * @license http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version SVN: $Id$
 * @link http://www.ingeneo.com.co
 *
 */

/**
 * ClientSiesa.php
 *
 * // SUS COMENTARIOS AQUI
 *
 * @category category
 * @package package
 * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2017 INGENEO S.A.S.
 * @license http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version Release: $Id$
 * @link http://www.ingeneo.com.co
 *
 */
class ClientSiesa extends Component
{

    /**
     * @const Valor por defecto para las sucursales
     */
    const CODE_BRANCH_DEFAULT = '001';

    /**
     * @const Nombre Categoria por defecto
     */
    const CATEGORY_DEFAULT_NAME = 'Otros';

    /**
     * @const Codigo Categoria por defecto
     */
    const CATEGORY_DEFAULT_CODE = 4;

    /**
     * Constructor de la clase
     *
     * @return void
     * @access public
     *
     * @version SVN: $Id$
     * @copyright 2017 INGENEO S.A.S.
     * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
     */
    public function __construct()
    {

    }

    /**
     * Funcion desctructora
     *
     * @return void
     * @access public
     *
     * @version SVN: $Id$
     * @copyright 2017 INGENEO S.A.S.
     * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
     */
    public function __destruct()
    {

    }

    /**
     * Retorna un array con la informacion de la bodega
     *
     * @param string $cliente String de busqueda
     *
     * @return array
     * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version Release: $Id$
     */
    public function getCellar($cellar)
    {
        # Consulra a la base de datos SQL server -------------------------------
        $sql = "
            SELECT f150_id as codigo, (f150_id + ' - ' + f150_descripcion) as descripcion
            FROM t150_mc_bodegas
            WHERE f150_id IS NOT NULL AND f150_ind_estado = 1
            AND (f150_id LIKE '%$cellar%' OR f150_descripcion LIKE '%$cellar%') 
            GROUP BY f150_id, f150_descripcion
            ORDER BY f150_descripcion ASC";
        return Yii::$app->dbsql->createCommand($sql)->queryAll();
    }

    public function getMultilocation($cellar)
    {
        # Consulra a la base de datos SQL server -------------------------------
        $sql = "
            SELECT f150_ind_multi_ubicacion as multilocation
            FROM t150_mc_bodegas
            WHERE f150_id IS NOT NULL AND f150_ind_estado = 1
            AND (f150_id LIKE '%$cellar%') 
            GROUP BY f150_id, f150_descripcion, f150_ind_multi_ubicacion
            ORDER BY f150_descripcion ASC";
        return Yii::$app->dbsql->createCommand($sql)->queryOne();
    }

    public function getLocationsMultilocationReference($cellar, $reference, $description)
    {
        # Consulra a la base de datos SQL server -------------------------------
        $sql = "
                SELECT 
                f155_id as id,
                f155_descripcion as descripcion
                FROM t401_cm_existencia_lote
                JOIN t121_mc_items_extensiones ON f121_rowid = f401_rowid_item_ext
                JOIN t120_mc_items ON f120_rowid = f121_rowid_item
                JOIN t150_mc_bodegas ON f150_rowid = f401_rowid_bodega
                JOIN t155_mc_ubicacion_auxiliares ON f401_id_ubicacion_aux = f155_id
                WHERE
                    f150_id LIKE '$cellar'
                    AND f120_referencia LIKE '$reference'
                    AND f401_cant_existencia_1 > 0
                    AND f155_ind_estado = '1'
                GROUP BY f155_id, f155_descripcion
                ORDER BY f155_descripcion DESC";
        return Yii::$app->dbsql->createCommand($sql)->queryAll();
    }

    //Maye
    public function getLotesMultilocationReference($cellar, $reference, $description)
    {
        # Consulra a la base de datos SQL server -------------------------------
        $sql = "
            SELECT RTRIM(LTRIM(f401_id_lote)) AS lote, f401_cant_existencia_1 AS disponible 
                FROM t401_cm_existencia_lote
                JOIN t121_mc_items_extensiones ON f121_rowid = f401_rowid_item_ext
                JOIN t120_mc_items ON f120_rowid = f121_rowid_item
                JOIN t150_mc_bodegas ON f150_rowid = f401_rowid_bodega
                WHERE
                    f150_id LIKE '$cellar'
                    AND f120_referencia LIKE '$reference'
                    AND f401_cant_existencia_1 > 0
                    AND f401_id_lote IS NOT NULL
                ORDER BY f401_id_lote DESC";
        return Yii::$app->dbsql->createCommand($sql)->queryAll();
    }

    public function getMultilocationReference($cellar, $reference, $description)
    {
        # Consulra a la base de datos SQL server -------------------------------
        $sql = "
            SELECT f150_ind_multi_ubicacion as multilocation
            FROM t150_mc_bodegas
            WHERE f150_id IS NOT NULL AND f150_ind_estado = 1
            AND (f150_id LIKE '%$cellar%') 
            GROUP BY f150_id, f150_descripcion, f150_ind_multi_ubicacion
            ORDER BY f150_descripcion ASC";
        return Yii::$app->dbsql->createCommand($sql)->queryAll();
    }

    /**
     * Método para obtener la lista de categorías
     * @return array|null
     */
    public function getCategories($plan_category)
    {
        $sql = "
              SELECT LTRIM(RTRIM(f106_id)) as 'f106_id', f106_descripcion
              FROM t106_mc_criterios_item_mayores
              WHERE f106_id_plan = '$plan_category'
              GROUP BY f106_id, f106_descripcion
              ORDER BY f106_descripcion";
        $raw = Yii::$app->dbsql->createCommand($sql)->queryAll();
        if (count($raw) > 0) {
            return ArrayHelper::map($raw, 'f106_id', 'f106_descripcion');
        }
        return NULL;
    }

    public function getCoPdv($listco)
    {
        $sql = "
            SELECT f285_id as codigo, (f285_id + ' - ' + f285_descripcion) as descripcion
            FROM t285_co_centro_op
            WHERE f285_id IN ('" . implode('\',\'', $listco['id']) . "')
            AND f285_descripcion IN ('" . implode('\',\'', $listco['name']) . "')
            GROUP BY f285_id, f285_descripcion
            ORDER BY f285_descripcion ASC";
        return Yii::$app->dbsql->createCommand($sql)->queryAll();
    }

    /**
     * Retorna un array con la informacion de la empresa
     *
     * @param string $cia String de busqueda
     *
     * @return array
     * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version Release: $Id$
     */
    public function getCia($cia)
    {
        # Consulra a la base de datos SQL server -------------------------------
        $sql = "
            SELECT f010_id as codigo, (cast(f010_id as varchar) + ' - ' + f010_razon_social) as descripcion
            FROM t010_mm_companias
            WHERE f010_id IS NOT NULL AND f010_ind_estado = 1
            AND (f010_id LIKE '%$cia%' OR f010_razon_social LIKE '%$cia%') 
            GROUP BY f010_id, f010_razon_social
            ORDER BY f010_razon_social ASC";
        return Yii::$app->dbsql->createCommand($sql)->queryAll();
    }

    /**
     * Retorna un array con los centros de operacion
     *
     * @param string $cliente String de busqueda
     *
     * @return array
     * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version Release: $Id$
     */
    public function getListco($co)
    {
        # Consulra a la base de datos SQL server -------------------------------
        $sql = "
            SELECT f285_id as codigo, (f285_id + ' - ' + f285_descripcion) as descripcion
            FROM t285_co_centro_op
            WHERE f285_id IS NOT NULL AND f285_ind_estado = 1
            AND (f285_id LIKE '%$co%' OR f285_descripcion LIKE '%$co%') 
            GROUP BY f285_id, f285_descripcion
            ORDER BY f285_descripcion ASC";
        return Yii::$app->dbsql->createCommand($sql)->queryAll();
    }

    /**
     * Retorna un array con los grupos relacionados a una compañia
     * @param $cia - id de la Compañia
     * @return mixed
     */
    public function getGroupsCo($cia)
    {
        $sql = "
            SELECT f222_id as codigo, (f222_id + ' - ' + f222_descripcion) as descripcion
            FROM t222_grupo_entidad
            WHERE f222_id_cia LIKE '%$cia%'
            GROUP BY f222_id, f222_descripcion
            ORDER BY f222_descripcion ASC";
        return Yii::$app->dbsql->createCommand($sql)->queryAll();
    }


    /**
     * Retorna un array con las unidades de negocio de un Grupo de Centros de Operaciones
     * @return mixed
     */
    public function getBusinessUnit($cia)
    {
        $sql = "
            SELECT f281_id as codigo, (f281_id + ' - ' + f281_descripcion) as descripcion
            FROM t281_co_unidades_negocio
            WHERE f281_id_cia LIKE '%$cia%'
            GROUP BY f281_id, f281_descripcion
            ORDER BY f281_descripcion ASC";
        return Yii::$app->dbsql->createCommand($sql)->queryAll();
    }

    /**
     * Retorna un array de centros de costos relacionados a un grupo
     * @param $group - id del grupo
     * @return mixed
     */
    public function getListCoByGroup($group, $cia)
    {
        $sql = "
            SELECT f285_id as codigo, (f285_id + ' - ' + f285_descripcion) as descripcion
            FROM t285_co_centro_op
            JOIN t223_detalle_grupo_entidad ON f223_id_co = f285_id
            WHERE f223_id_grupo_entidad LIKE '%$group%'
            AND f285_id_cia LIKE '%$cia%'
            ORDER BY f285_descripcion ASC";
        return Yii::$app->dbsql->createCommand($sql)->queryAll();
    }

    /**
     * Retorna un array con la informacion (Nit,Razon social) del cliente
     *
     * @param string $cliente String de busqueda
     *
     * @return array
     * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version Release: $Id$
     */
    public function getPdvs($cia)
    {
        $sql = "
            SELECT f200_nit as nit, (f200_nit + ' - ' + f200_razon_social) as razon_social
            FROM t200_mm_terceros
            JOIN t211_mm_funcionarios ON f211_rowid_tercero = f200_rowid
            WHERE f200_nit IS NOT NULL AND f200_nit != '' 
            AND f200_ind_estado = 1
            AND (f200_id_cia LIKE '%$cia%') 
            GROUP BY f200_nit, f200_razon_social
            ORDER BY f200_razon_social ASC";
        return Yii::$app->dbsql->createCommand($sql)->queryAll();
    }

    /**
     * Retorna un array con la informacion (Nit,Razon social) del cliente
     *
     * @param string $cliente String de busqueda
     *
     * @return array
     * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version Release: $Id$
     */
    public function getPdvsUser($cia)
    {
        $sql = "
            SELECT f200_nit as nit, (f200_nit + ' - ' + f200_razon_social) as razon_social
            FROM t200_mm_terceros
            JOIN t211_mm_funcionarios ON f211_rowid_tercero = f200_rowid
            WHERE f200_nit IS NOT NULL AND f200_nit != '' 
            AND f200_ind_estado = 1 AND f200_ind_interno = 1
            AND (f200_id_cia LIKE '%$cia%') 
            GROUP BY f200_nit, f200_razon_social
            ORDER BY f200_razon_social ASC";
        return Yii::$app->dbsql->createCommand($sql)->queryAll();
    }

    /**
     * Retorna un los codigos por punto de venta
     *
     * @param string $cliente String de busqueda
     *
     * @return array
     * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version Release: $Id$
     */
    public function getPdvsCodes($cia, $codes)
    {
        $sql = "
            SELECT f200_nit as nit, (f200_nit + ' - ' + f200_razon_social) as razon_social
            FROM t200_mm_terceros
            JOIN t211_mm_funcionarios ON f211_rowid_tercero = f200_rowid
            WHERE f200_nit IN ('" . implode('\',\'', $codes) . "')
            AND f200_ind_estado = 1 AND f200_ind_interno = 1
            AND (f200_id_cia LIKE '%$cia%') 
            GROUP BY f200_nit, f200_razon_social
            ORDER BY f200_razon_social ASC";
        return Yii::$app->dbsql->createCommand($sql)->queryAll();
    }

    /**
     * Metodo para obtener la informacion del vendedor para el nit y sucursal
     * seleccionados
     *
     * @param integer $nit Nit del cliente
     * @param string $sucursal Id de la sucursal
     *
     * @return type
     * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version SVN: $Id$
     */
    public static function getInventarioRef($referencia, $idBodega)
    {
        $disponible = 0;
        if (!empty($referencia) && !empty($idBodega)) {

            try {
                $date = date('Y-m-d');
                $date = date_format($date, 'Y-m-d H:i:s');

                $sql = "
                    SELECT
                        t470.f470_rowid_item_ext AS item,
                        t150.f150_id As dodega,
                        Sum(CASE WHEN t470.f470_ind_naturaleza = 1 THEN t470.f470_cant_1 ELSE t470.f470_cant_1*-1 END) As disponible,
                        MIN(t470.f470_precio_uni) AS precio
                    FROM
                        (t150_mc_bodegas t150 Right Outer Join
                            t470_cm_movto_invent t470 
                         On t150.f150_rowid = t470.f470_rowid_bodega)
                    JOIN t121_mc_items_extensiones ON f121_rowid = t470.f470_rowid_item_ext
                    JOIN t120_mc_items ON f120_rowid = f121_rowid_item
    
                    WHERE
                        t470.f470_id_fecha <= '" . $date . "' 
                        AND t470.f470_ind_estado_cm <> '2' 
                        -- AND t470.f470_ind_tipo_item = 1
                        AND t150.f150_id = '" . $idBodega . "'
                        AND f120_referencia = '" . $referencia . "'
                            
                    GROUP BY t470.f470_rowid_item_ext, t150.f150_id";
                $data = Yii::$app->dbsql->createCommand($sql)->queryOne();
                if (count($data) > 0) {
                    $disponible = $data['disponible'];
                }
            } catch (Exception $exc) {
                \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                    . print_r($exc->getMessage(), true) . '}', 'webservices');
            }
        }
        return $disponible;
    }

    /**
     * Method to obtain References by Category
     * @param $id_cia
     * @param $category
     * @return string
     */
    public function getReferencesByCategory($id_cia, $category, $exception_initial, $plan_category)
    {
        $arrayResult = '';

        try {
            $query = '';
            if (empty($exception_initial) == false && $exception_initial != '-') {
                foreach ($exception_initial as $key => $value) {
                    $query .= "AND f120_referencia NOT LIKE '$value%' ";
                }
            }

            $sql = "SET NOCOUNT ON;
                DECLARE @Cia char(3)
                
                SET @Cia = $id_cia
                
                SELECT
                f120_id as item, 
                f120_descripcion as description, 
                REPLACE(LTRIM(RTRIM(f120_referencia)), ' ', '-') AS reference, 
                t470_cm_movto_invent.f470_cant_1 as 'cantidad',
                t470_cm_movto_invent.f470_costo_prom_tot as 'costo_promedio_total',
                t470_cm_movto_invent.f470_costo_prom_uni as 'f470_costo_prom_uni',
                t120_mc_items.f120_id_unidad_inventario as measured_unit,
                ISNULL(LTRIM(RTRIM(f106_id)),1) AS id_category, 
                ISNULL(f106_descripcion, 'Todos') AS name_category
               
                FROM t120_mc_items
                /*JOIN t470_cm_movto_invent ON f120_rowid = f470_rowid_item_ext AND f470_rowid = (SELECT TOP 1 MAX(f470_rowid) 
                   FROM t470_cm_movto_invent WHERE f470_rowid_item_ext = f120_rowid 
                    AND f470_id_concepto = '610'
                   GROUP BY f470_rowid, f470_id_fecha 
                   ORDER BY f470_id_fecha DESC)*/
		        JOIN t470_cm_movto_invent ON f120_rowid = f470_rowid_item_ext AND f470_rowid = (SELECT MAX(f470_rowid) 
                   FROM t470_cm_movto_invent WHERE f470_rowid_item_ext = f120_rowid AND f470_id_concepto = 610)

                LEFT JOIN t125_mc_items_criterios ON f120_rowid = f125_rowid_item
                LEFT JOIN t106_mc_criterios_item_mayores ON f106_id_plan = f125_id_plan AND f106_id = f125_id_criterio_mayor 
                JOIN t150_mc_bodegas ON t470_cm_movto_invent.f470_rowid_bodega = f150_rowid 
                JOIN t121_mc_items_extensiones ON f120_rowid = f121_rowid_item
                
                WHERE 
                f106_id = $category 		
		        AND f470_id_concepto = 610
		        AND f121_ind_estado = 1 
                AND f106_id_plan = '$plan_category'
                AND f120_id_cia = @Cia
                $query
                
                GROUP BY 
                
                f120_id,
                f120_descripcion,
                f120_referencia,
                f470_cant_1,
                f470_costo_prom_tot,
                f470_costo_prom_uni,
                f120_id_unidad_inventario,
                f106_id,
                f106_descripcion
                
                ORDER BY f120_descripcion ASC";
                
                // \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                //     . print_r($sql, true) . '}', 'webservices');

            $arrayResult = Yii::$app->dbsql->createCommand($sql)->queryAll();

        } catch (Exception $exc) {
            die('a');
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                . print_r($exc->getMessage(), true) . '}', 'webservices');
        }
        return $arrayResult;
    }

    /**
     * Method to obtain current quantity of Inventory by Reference and Warehouse
     * @param $id_cia
     * @param $reference
     * @param $cellar
     * @return string
     */
    public function getInfoReferencesInventory($id_cia, $references, $cellars, $exception_initial, $plan_category)
    {
        $arrayResult = '';
        $cellars = implode("', '", $cellars);
        $references = implode("', '", $references);

        try {
            $query = '';
            if (empty($exception_initial) == false && $exception_initial != '-') {
                foreach ($exception_initial as $key => $value) {
                    $query .= "AND f120_referencia NOT LIKE '$value%' ";
                }
            }

            $sql = "
                SELECT 
                    f120_descripcion as description, 
                    REPLACE(LTRIM(RTRIM(f120_referencia)), ' ', '-') AS reference, 
                    disp.cellar_id,
                    disp.cellar_name,
                    disp.current_inventory, 
                    t470_cant.f470_costo_prom_uni AS price
                FROM t120_mc_items AS items
                
                -- Cantidades Disponibles
                INNER JOIN (SELECT
                     t470.f470_rowid_item_ext AS item,
                     t150.f150_id As cellar_id,
                     t150.f150_descripcion As cellar_name,
                     Sum(CASE WHEN t470.f470_ind_naturaleza = 1 THEN t470.f470_cant_1 ELSE t470.f470_cant_1*-1 END) As current_inventory
                 FROM
                     (t150_mc_bodegas t150 Right Outer Join
                         t470_cm_movto_invent t470 
                      On t150.f150_rowid = t470.f470_rowid_bodega)
                 JOIN t121_mc_items_extensiones ON f121_rowid = t470.f470_rowid_item_ext
                 JOIN t120_mc_items ON f120_rowid = f121_rowid_item
                
                 WHERE
                     t470.f470_id_fecha <= '" . date('Y-m-d') . "'  
                     AND t470.f470_ind_estado_cm <> '2' 
                     -- AND t470.f470_ind_tipo_item = 1
                     AND T150.f150_id IN ('$cellars')
                          
                 GROUP BY t470.f470_rowid_item_ext, t150.f150_id, t150.f150_descripcion) as disp ON disp.item = f120_rowid
                
                -- Precio 
                
                LEFT JOIN t470_cm_movto_invent t470_cant ON f120_rowid = f470_rowid_item_ext AND f470_rowid = (SELECT TOP 1 MAX(f470_rowid) 
                     FROM
                     (t150_mc_bodegas t150_1 Right Outer Join
                         t470_cm_movto_invent t470_1 
                      On t150_1.f150_rowid = t470_1.f470_rowid_bodega)
                    JOIN t121_mc_items_extensiones ON f121_rowid = t470_1.f470_rowid_item_ext
                    JOIN t120_mc_items ON f120_rowid = f121_rowid_item
                     WHERE t470_1.f470_rowid_item_ext = items.f120_rowid AND t150_1.f150_id IN ('$cellars')
                     AND t470_1.f470_id_concepto = '610'
                     GROUP BY t470_1.f470_rowid, t470_1.f470_ts 
                     ORDER BY t470_1.f470_ts DESC)
                
                WHERE
                f120_referencia IN ('$references')
                
                GROUP BY 
                f120_descripcion, 
                f120_referencia, 
                disp.cellar_id, 
                disp.cellar_name, 
                disp.current_inventory,
                t470_cant.f470_cant_1,
                t470_cant.f470_costo_prom_uni";
            $arrayResult = Yii::$app->dbsql->createCommand($sql)->queryAll();
        } catch (Exception $exc) {
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                . print_r($exc->getMessage(), true) . '}', 'webservices');
        }
        return $arrayResult;
    }

    /**
     * Method to obtain current quantity of Inventory by Reference and Warehouse
     * @param $id_cia
     * @param $reference
     * @param $cellar
     * @return string
     */
    public function getLastPriceInventory($references)
    {

        try {
            $references = implode("', '", $references);

            $sql = "
                SELECT
                    f120_descripcion as description, 
                    REPLACE(LTRIM(RTRIM(f120_referencia)), ' ', '-') AS reference, 
                    (CASE WHEN t470_cant.f470_cant_1 > 0 THEN t470_cant.f470_costo_prom_tot/t470_cant.f470_cant_1 ELSE t470_cant.f470_costo_prom_tot END) AS price
                FROM t120_mc_items AS items
            
                -- Precio 
                LEFT JOIN t470_cm_movto_invent t470_cant ON f120_rowid = f470_rowid_item_ext AND f470_rowid = (SELECT TOP 1 MAX(f470_rowid) 
                     FROM
                     (t150_mc_bodegas t150_1 Right Outer Join
                         t470_cm_movto_invent t470_1 
                      On t150_1.f150_rowid = t470_1.f470_rowid_bodega)
                    JOIN t121_mc_items_extensiones ON f121_rowid = t470_1.f470_rowid_item_ext
                    JOIN t120_mc_items ON f120_rowid = f121_rowid_item
                     WHERE t470_1.f470_rowid_item_ext = items.f120_rowid
                     GROUP BY t470_1.f470_rowid, t470_1.f470_id_fecha 
                     ORDER BY t470_1.f470_id_fecha DESC)
                
                WHERE
                f120_referencia IN ('$references')
                
                GROUP BY 
                f120_descripcion, 
                f120_referencia, 
                t470_cant.f470_cant_1,
                t470_cant.f470_costo_prom_tot";
            $arrayResult = Yii::$app->dbsql->createCommand($sql)->queryAll();
        } catch (Exception $exc) {
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                . print_r($exc->getMessage(), true) . '}', 'webservices');
        }
        return $arrayResult;
    }

    public function getInfoReference($reference, $plan_category)
    {
        try {
            $sql = "SET NOCOUNT ON;
               SELECT 
                f120_id as item, 
                f120_descripcion as description, 
                REPLACE(LTRIM(RTRIM(f120_referencia)), ' ', '-') AS reference,
                t470_cm_movto_invent.f470_cant_1 as 'cantidad',
                t470_cm_movto_invent.f470_costo_prom_tot as 'costo_promedio_total',
                t470_cm_movto_invent.f470_costo_prom_uni as 'f470_costo_prom_uni',
                t120_mc_items.f120_id_unidad_inventario as measured_unit,
                ISNULL(LTRIM(RTRIM(f106_id)),1) AS id_category, 
                ISNULL(f106_descripcion, 'Todos') AS name_category
           
                FROM t120_mc_items
                JOIN t470_cm_movto_invent ON f120_rowid = f470_rowid_item_ext AND f470_rowid = (SELECT TOP 1 MAX(f470_rowid) 
                   FROM t470_cm_movto_invent WHERE  f470_rowid_item_ext = f120_rowid  
                   AND f470_id_concepto = '610'
                   GROUP BY f470_rowid, f470_id_fecha 
                   ORDER BY f470_id_fecha DESC)
                LEFT JOIN t125_mc_items_criterios ON f120_rowid = f125_rowid_item
                LEFT JOIN t106_mc_criterios_item_mayores ON f106_id_plan = f125_id_plan AND f106_id = f125_id_criterio_mayor 
                JOIN t150_mc_bodegas ON t470_cm_movto_invent.f470_rowid_bodega = f150_rowid
                JOIN t121_mc_items_extensiones ON f120_rowid = f121_rowid_item
                
                WHERE 
                f120_referencia = '$reference->reference'  
                AND f121_ind_estado = 1 
		        AND f470_id_concepto = '610'
                AND f120_descripcion = '$reference->description'  
                AND f106_id_plan = '$plan_category'
                
                GROUP BY 
                
                f120_id,
                f120_descripcion,
                f120_referencia,
                f470_cant_1,
                f470_costo_prom_tot,
                f470_costo_prom_uni,
                f120_id_unidad_inventario,
                f106_id,
                f106_descripcion";
            $arrayResult = Yii::$app->dbsql->createCommand($sql)->queryOne();
        } catch (Exception $exc) {
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                . print_r($exc->getMessage(), true) . '}', 'webservices');
        }
        return $arrayResult;
    }

    /**
     * Metodo para obtener la unidad de medida del item
     *
     * @param int $reference Referencia del item
     *
     * @return boolean
     * @throws \Exception
     * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version Release: $Id$
     */
    public function getMesureUnit($references, $cia)
    {
        try {
            if (!empty($references) && is_array($references) && !empty($cia)) {
                $sql = "
                SELECT RTRIM(LTRIM(f120_referencia)) AS f120_referencia, 
                    RTRIM(LTRIM(f120_id_unidad_inventario)) as f120_id_unidad_orden
                FROM t120_mc_items 
                WHERE f120_referencia IN ('"
                    . implode("','", $references)
                    . "') AND f120_id_cia = '" . $cia . "'";
                $result = Yii::$app->dbsql->createCommand($sql)->queryAll();
                if (count($result) > 0) {
                    return $result;
                }
            }
        } catch (\Exception $exc) {
            throw new \Exception($exc);
        }
        return false;
    }

    /**
     * Retorna un array con la informacion de la bodega
     *
     * @param string $cliente String de busqueda
     *
     * @return array
     * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version Release: $Id$
     */
    public function getInfoCellar($cellar)
    {
        # Consulra a la base de datos SQL server -------------------------------
        $sql = "
            SELECT 
                f150_id as codigo, 
                (f150_id + ' - ' + f150_descripcion) as descripcion,
                f150_ind_multi_ubicacion,
                f150_ind_lotes,
                f150_ind_costos
            FROM t150_mc_bodegas
            WHERE f150_id IS NOT NULL AND f150_ind_estado = 1
            AND f150_id = '$cellar' 
            GROUP BY f150_id, f150_descripcion, f150_ind_multi_ubicacion,
                f150_ind_lotes,
                f150_ind_costos
            ORDER BY f150_descripcion ASC";
        return Yii::$app->dbsql->createCommand($sql)->queryOne();
    }

    /**
     * Metodo para obtener el ultimo lote de cada referencia
     *
     * @param array $references Referencias
     * @param int $cia Compania
     * @param int $cellarIn Bodega entrada
     *
     * @return boolean
     * @throws \Exception
     * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version Release: $Id$
     */
    public function getLastLot($references, $cia, $cellarIn)
    {
        $result = [];
        try {
            if (!empty($cia)) {
                $sql = "
                SELECT top " . count($references) . " RTRIM(LTRIM(f401_rowid_bodega)), 
                    RTRIM(LTRIM(f120_referencia)) as f120_referencia, 
                    RTRIM(LTRIM(f401_id_lote)) AS lote 
                FROM t401_cm_existencia_lote
                JOIN t121_mc_items_extensiones ON f121_rowid = f401_rowid_item_ext
                JOIN t120_mc_items ON f120_rowid = f121_rowid_item
                JOIN t150_mc_bodegas ON f150_rowid = f401_rowid_bodega
                WHERE f120_referencia IN ('"
                    . implode("','", $references)
                    . "') AND f150_id = '$cellarIn'
                    AND f401_id_cia = '$cia'
                ORDER BY f401_id_lote DESC ";
                $result = Yii::$app->dbsql->createCommand($sql)->queryAll();
            }
        } catch (\Exception $exc) {
            throw new \Exception($exc);
        }
        return $result;
    }

    /**
     * Metodo para obtener el ultimo costo de los item
     *
     * @param array $references Referencias
     * @param int $cia Compania
     *
     * @return boolean
     * @throws \Exception
     * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version Release: $Id$
     */
    public function getLastCost($references, $cia)
    {
        $result = [];
        try {
            if (!empty($cia)) {
                $sql = "  
                SELECT
                        RTRIM(LTRIM(f120_referencia)) as f120_referencia,  
                        ISNULL(f132_ultimo_costo_local,0) AS costo,
                        f132_ts
                FROM t120_mc_items
                JOIN t121_mc_items_extensiones ON f121_rowid_item = f120_rowid
                LEFT JOIN T132_Mc_items_instalacion ON f132_rowid_item_ext = f121_rowid
                AND f132_ts = (
						 SELECT TOP 1
	                        f132_ts
	                FROM T132_Mc_items_instalacion 
						 WHERE f132_rowid_item_ext = f121_rowid 
						 ORDER BY f132_ts DESC
					 )
                WHERE f120_referencia IN ('"
                    . implode("','", $references)
                    . "') 
                  AND f132_id_cia = '$cia'
                ORDER BY f132_ts DESC";

                $result = Yii::$app->dbsql->createCommand($sql)->queryAll();
            }
        } catch (\Exception $exc) {
            throw new \Exception($exc);
        }
        return $result;
    }

    /**
     * Retorna un array con la informacion del funcionario
     *
     * @param string $nit Nit del PDV
     *
     * @return array
     * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version Release: $Id$
     */
    public function getCodeApplicant($nit)
    {
        $sql = "
            SELECT f211_id as codigo, f200_nit as nit, (f200_nit + ' - ' + f200_razon_social) as razon_social
            FROM t200_mm_terceros
            JOIN t211_mm_funcionarios ON f211_rowid_tercero = f200_rowid
            WHERE f200_nit IS NOT NULL AND f200_nit != '' 
            AND f200_ind_estado = 1 -- AND f200_ind_interno = 1
            AND f200_nit = '$nit'
            GROUP BY f211_id, f200_nit, f200_razon_social
            ORDER BY f200_razon_social ASC";
        return Yii::$app->dbsql->createCommand($sql)->queryOne();
    }

    /**
     * Metodo para la consulta de productos
     *
     * @param int $nit Nit del cliente
     * @param string $cia Codigo de la empresa
     *
     * @return array
     * @author Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version Release: $Id$
     *
     */
    public static function getProductos($nit, $cia, $plan_category)
    {
        if (!empty($nit) && !empty($cia)) {
            $sqlPrd = "
            SET NOCOUNT ON;
            DECLARE @Fecha_Final Datetime, @Nit_Cliente char(13)

            SET @Nit_cliente = '" . $nit . "'
            SET @Fecha_Final = '' 

            SELECT DISTINCT 
            'siesa' as erp,
            f120_rowid as id, 
            f126_id_lista_precio as lista_precio,
            f120_id_unidad_orden as unidad_medida,
            REPLACE(LTRIM(RTRIM(f120_referencia)), ' ', '-') as 'referencia', 
            f120_descripcion as 'descripcion', 
            ISNULL(LTRIM(RTRIM(f106_id)),1) as 'categoria_id', 
            ISNULL(f106_descripcion, 'Todos') as 'nombre_categoria',
            ISNULL((qry_consumo.Periodo-qry_consumo.consumo)/nullif(qry_consumo.Periodo,0),0)*100 as variacion,
            ISNULL(qry_consumo.consumo,0) as  consumo,
            0 as  'cantidad_disponible',
            f126_fecha_ts_actualizacion as fecha_actualizacion
            
            FROM t126_mc_items_precios
            JOIN (SELECT f126_rowid_item AS 'idItem', 
                     f126_id_lista_precio as 'lista',							
                     MAX(f126_fecha_ts_actualizacion) AS 'fecha',
                     f201_id_co_factura AS idCo
                    FROM t126_mc_items_precios
                    JOIN t201_mm_clientes ON f201_id_lista_precio = f126_id_lista_precio
                    JOIN t200_mm_terceros ON f200_rowid = f201_rowid_tercero
                    WHERE f200_nit = @Nit_cliente
                    GROUP BY f126_rowid_item, f126_id_lista_precio, f201_id_co_factura) AS t 
            ON t.idItem = f126_rowid_item AND t.fecha = f126_fecha_ts_actualizacion AND t.lista = f126_id_lista_precio
            JOIN t120_mc_items ON f126_rowid_item = f120_rowid
            JOIN t121_mc_items_extensiones ON f120_rowid = f121_rowid_item
            LEFT JOIN t113_mc_grupos_impositivos ON f120_id_grupo_impositivo = f113_id
            LEFT JOIN t114_mc_grupos_impo_impuestos ON f113_id = f114_grupo_impositivo
            LEFT JOIN t037_mm_llaves_impuesto ON f114_id_llave_impuesto = f037_id
            LEFT JOIN t125_mc_items_criterios ON f120_rowid = f125_rowid_item
            LEFT JOIN t106_mc_criterios_item_mayores ON f106_id_plan = f125_id_plan AND f106_id = f125_id_criterio_mayor
				
            LEFT JOIN (
                Select 
                MFV.f470_rowid_item_ext as row_item,
                t200.f200_nit as tercero,
                fv.f461_id_sucursal_fact as suc, 
                sum(CASE WHEN MFV.F470_ID_CONCEPTO = '502' AND MFV.F470_ID_PERIODO = (YEAR(@Fecha_Final)*100+MONTH(@Fecha_Final))
                THEN MFV.f470_cant_1*-1 ELSE MFV.f470_cant_1 END) AS Periodo,
                sum(CASE WHEN MFV.F470_ID_CONCEPTO = '502' THEN MFV.f470_cant_1*-1 ELSE MFV.f470_cant_1 END)/6 AS Consumo
                from
                t470_cm_movto_invent MFV INNER JOIN t461_cm_docto_factura_venta FV
                ON MFV.f470_rowid_docto_fact = FV.f461_rowid_docto
                INNER JOIN t200_mm_terceros T200
                ON T200.f200_rowid = fv.f461_rowid_tercero_fact
                group by MFV.f470_rowid_item_ext,
                t200.f200_nit,
                fv.f461_id_sucursal_fact) Qry_Consumo 
                ON f121_rowid_item = qry_consumo.row_item 
                and qry_consumo.tercero = @Nit_cliente			

            WHERE  
            f121_ind_estado = 1
            AND f106_id_plan = '$plan_category'
            ORDER BY f120_descripcion ASC";

            $raw = Yii::$app->dbsql->createCommand($sqlPrd)->queryAll();

            if (count($raw) > 0) {
                return $raw;
            }
        }
        return array();
    }
}