<?php
namespace app\components;

use Yii;
use yii\base\Component;

/**
 * HeaderOrder.php
 *
 * PHP Version 5.3.0
 * 
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2018 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */

/**
 * HeaderOrder.php
 *
 * // SUS COMENTARIOS AQUI
 *
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2018 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   Release: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */
class HeaderOrder extends Component {

    /**
     * Numero de registro
     * @var int 
     */
    public $numeroReg;

    /**
     * Tipo de registro
     * @var int 
     */
    public $tipoReg;

    /**
     * Subtipo de registro
     * @var int 
     */
    public $subTipoReg;

    /**
     * version del tipo de registro
     * @var int 
     */
    public $versionReg;

    /**
     * Compañia
     * @var int 
     */
    public $cia;

    /**
     * Indica si el numero consecutivo de docto es manual o automático
     * @var int 
     */
    public $consecAutoReg;

    /**
     * Centro de operación del documento
     * @var string
     */
    public $idCo;

    /**
     * Tipo de documento
     * @var string
     */
    public $idTipoDocto;

    /**
     * Numero de documento
     * @var int 
     */
    public $consecDocto;

    /**
     * Fecha del documento
     * @var string
     */
    public $idFecha;
    
    /**
     * Tercero
     * @var string
     */
    public $idTercero;
    
    /**
     * Tercero solicitante
     * @var string
     */
    public $idTerceroSolicitante;

    /**
     * Fecha entrega del pedido
     * @var string
     */
    public $fechaEntrega;

    /**
     * Nro. dias de entrega del documento
     * @var int 
     */
    public $numDiasEntrega;
    
        /**
     * Clase interna del documento
     * @var int 
     */
    public $idClaseDocto;

    /**
     * Estado del documento
     * @var int 
     */
    public $indEstado;

    /**
     * Estado de impresión del documento
     * @var int 
     */
    public $indImpresion;

    /**
     * Observaciones del documento
     * @var string
     */
    public $notas;
    
    /**
     * Concepto
     * @var int
     */
    public $idConcepto;
    
    /**
     * Bodea de salida
     * @var string
     */
    public $idBodegaSalida;
    
    /**
     * Bodega de entrada
     * @var string
     */
    public $idBodegaEntrada;
    
    /**
     * Referencia del documento
     * @var string
     */
    public $referencia;
    
    /**
     * Ubicacion de entrada
     * @var string 
     */
    public $idUbicacionEnt;
    
    /**
     * Numero de cargue
     * @var string
     */
    public $idCargue;
    
    /**
     * Orden de compra del Documento
     * @var string
     */
//    public $numDoctoReferencia;
    
    /**
     * Codigo del proyecto
     * @var string
     */
//    public $idProyecto;

    /**
     * Listado de las variables de tipo Int con el tamaño
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2018 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function lehgthVarsInt()
    {
        return array(
            'numeroReg' => 7,
            'tipoReg' => 4,
            'subTipoReg' => 2,
            'versionReg' => 2,
            'cia' => 3,
            'consecAutoReg' => 1,
            'consecDocto' => 8,
            'numDiasEntrega' => 3,
            'idClaseDocto' => 3,
            'indEstado' => 1,            
            'indImpresion' => 1,
            'idConcepto' => 3,
            
        );
    }

    /**
     * Listado de las variables de tipo String con el tamaño
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2018 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function lehgthVarsString()
    {
        return array(
            'idCo' => 3,
            'idTipoDocto' => 3,
            'idFecha' => 8,            
            'idTercero' => 15,  
            'idTerceroSolicitante' => 5,            
            'fechaEntrega' => 8,
            'notas' => 255,
            'idBodegaSalida' => 5,
            'idBodegaEntrada' => 5,
            'referencia' => 20,
            'idUbicacionEnt' => 10,
            'idCargue' => 10,
//            'numDoctoReferencia' => 50,
//            'idProyecto' => 15,          
        );
    }

}

?>
