<?php
namespace app\components;

use Yii;
use yii\base\Component;
use app\components\ClientTecno;
use yii\db\Expression;

/**
 * HelperOrderTECNO.php
 *
 * PHP Version 5.5.0
 * 
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2015 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */

/**
 * HelperOrderTECNO.php
 *
 * // SUS COMENTARIOS AQUI
 *
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2015 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
 * @version   Release: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */
class HelperOrderTECNO extends Component {

    ## Constantes para la cabecera del peiddo ----------------------------------
    const NUMERO_ENTREGAS = 1;
    const DIAS_VALIDEZ = 0;
    const DESCUENTO_PIE = 0;
    const ANULADO = 0;
    const PC = 'PEDIDO B2BEXPRESS';    
    const DURACION = 0;    
    const CONCEPTO = 0;    
    const MONEDA = 1;    
    const DESPACHO = 'N';    
    const ABONO = 0;    
    const PRIORIDAD = 'M';    
    const SW = 9;    
    const PORC_PENDIENTE = 100;    
    const FORMAENVIO = 1;    
    const TRANSPORTADOR = 0;    
    const COMISION_VENDEDOR = 0;    
    const TASA_MONEDA_EXT = 1;    
    const CERTIFICADO_COMPLETACION = 0;    
    const PUNTO_FOB = ' ';    
    const COD_MOTIVO_ANULACIONES = 0;    
    const TELEFONO2 = ' ';    
    const EXPORTADO = 'N';    
    const TIPO_DESTINO = NULL;    
    const RETENCION_1 = 0;       
    const CONDICIONES = 2;       
    const BODEGA = 2;       
    
    # Constantes para los items ------------------------------------------------
    const CANTIDAD_DESPACHADA = 0;
    const PORCENTAJE_DESCUENTO = 0;
    const UND = 1;
    const CANTIDAD_UND = 1;
    const DESPACHO_VIRTUAL = 0;
    const PORC_DCTO_2 = 0;
    const PORC_DCTO_3 = 0;
    const SW_ITEM = 9;
    const EXPORTADO_ITEM = 'N';
    const NUMERO_LOTE = 0;
    const TIPO_DESTINO_ITEM = NULL;
    const ENVASE = 0;
    const PORCENTAJE_RETEFUENTE = 0;
    const DIRECCION_ENVIO = 1;    
    const DIRECCION_FACTURA = 1;    

    /**
     *
     * @var ClientTecno 
     */
    private $_clientTecno;
    
    private $_infoSucursal;
    public $idPedido;
    
    /**
     * Constructor de la calse
     */
    public function __construct() {
        $this->_clientTecno = new ClientTecno;
    }
    
    /**
     * Crea un array con los datos para la cabecera del pedido
     * 
     * @param object $pedido 
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function createHeader($pedido){         
        #Obetenemos el numero del pedido ---------------------------------------
        $this->idPedido = $this->_clientTecno->getLastId();        
        # Obtenemos los datos del nit ------------------------------------------
        $this->_infoSucursal = ClientTecno::getInfoBranch($pedido->nit, $pedido->nombre_sucursal);
        # ----------------------------------------------------------------------
        if(count($this->_infoSucursal) > 0){            
            return [
                'numero_pedido' => $this->idPedido,
                'nit' => $pedido->nit,                
                'direccion_entrega' => self::DIRECCION_ENVIO,                
                'direccion_factura' => self::DIRECCION_FACTURA,
                'vendedor' => $this->_infoSucursal['id_vendedor'],
                'fecha_hora_pedido' => new Expression("convert(datetime, '".date('Y-m-d H:i:s')."')"),
                'fecha_hora_limite_entrega' => new Expression("convert(datetime, '".$pedido->fecha."')"), 
                'fecha_hora_entrega' => new Expression("convert(datetime, '".date('Y-m-d H:i:s', mktime(0, 0, 0, date('m'), date('d')+1, date('Y')))."')"),
                'numero_entregas' => self::NUMERO_ENTREGAS,
                'condicion' => self::CONDICIONES,
                'dias_validez' => self::DIAS_VALIDEZ,
                'descuento_pie' => self::DESCUENTO_PIE,
                'valor_total' => $pedido->total_iva,
                'anulado'  =>  self::ANULADO,
                'notas' => 'No. Pedido B2BExpress: '.$pedido->id.' -- '.$pedido->descripcion,
                'usuario' => Yii::$app->user->identity->username,
                'pc' => self::PC,
                'duracion' => self::DURACION,
                'concepto' => self::CONCEPTO,
                'moneda' => self::MONEDA,
                'despacho' => self::DESPACHO,
                'nit_destino' => $pedido->nit,
                'abono' => self::ABONO,
                'prioridad' => self::PRIORIDAD,
                'sw' => self::SW,
                'bodega' => self::BODEGA,
                'NroOCTercero' => $pedido->numero_pedido,
//                'telefono1' => $this->_infoSucursal['telefono_1'],
                'porc_pendiente' => self::PORCENTAJE_DESCUENTO,
                'IdFormaEnvio' => self::FORMAENVIO,
                'IdTRansportador' => self::TRANSPORTADOR,
                'Comision_Vendedor' => self::COMISION_VENDEDOR,
                'Tasa_Moneda_ext' => self::TASA_MONEDA_EXT,
//                'Contacto_Compras' => $pedido->razon_social,
//                'Contacto_Pagos' => $pedido->razon_social,
                'Certificado_Completacion' => self::CERTIFICADO_COMPLETACION,
                'Punto_FOB' => self::PUNTO_FOB,
                'Cod_Motivo_Anulaciones' => self::COD_MOTIVO_ANULACIONES,
                'Telefono2' => self::TELEFONO2,
                'Exportado' => self::EXPORTADO,
                'Tipo_Destino' => self::TIPO_DESTINO,
                'Retencion_1' => self::RETENCION_1,
            ];
        }
        return [];
    }
    
    /**
     * Crea un array con los datos para cada item
     * 
     * @param object  $detallePedido Objeto con la informacion de cada item
     * @param integer $countItem     Objeto con la informacion de cada item
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function createItem($detallePedido, $countItem){        
        if(count($this->_infoSucursal) > 0){
            return [
                'numero_pedido' => $this->idPedido,
                'IdProducto' => $detallePedido->referencia,
                'cantidad' => $detallePedido->cantidad,
                'cantidad_despachada' => self::CANTIDAD_DESPACHADA,
                'valor_unitario' => $detallePedido->precio_sin_iva,
                'porcentaje_iva' => $detallePedido->iva,
                'porcentaje_descuento' => self::PORCENTAJE_DESCUENTO,
                'und' => self::UND,
                'cantidad_und' => self::CANTIDAD_UND,
                'nota' => $detallePedido->notas,
                'despacho_virtual' => self::DESPACHO_VIRTUAL,
                'porc_dcto_2'  =>  self::PORC_DCTO_2,
                'porc_dcto_3' => self::PORC_DCTO_3,                
                'sw' => self::SW,
                'bodega' => self::BODEGA,
                'fecha_hora_entrega' => date('Y-m-d', mktime(0, 0, 0, date('m'), date('d')+1, date('Y'))),
                'MaxCantidad' => $detallePedido->cantidad,
                'MinCantidad' => $detallePedido->cantidad,
                'DireccionEnvio' => self::DIRECCION_ENVIO,
                'IdVendedor' => $this->_infoSucursal['id_vendedor'],
                'IdCliente' => $this->_infoSucursal['nit'],
                'DireccionFactura' => self::DIRECCION_FACTURA,
                'Producto' => $detallePedido->descripcion,
                'Linea' => $countItem,
                'Exportado' => self::EXPORTADO_ITEM,
                'Numero_Lote' => self::NUMERO_LOTE,
                'Tipo_Destino' => self::TIPO_DESTINO_ITEM,
                'Envase' => self::ENVASE,
                'Porcentaje_ReteFuente' => self::PORCENTAJE_RETEFUENTE  
            ];
        }
        return [];
    }
    
}

?>
