<?php

/**
 * HelperFile.php
 *
 * PHP Version 5.3.0
 * 
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2014 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */

/**
 * HelperFile.php
 *
 * // SUS COMENTARIOS AQUI
 *
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2014 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
 * @version   Release: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */
class HelperFile
{

    /**
     * Constructor de la clase
     * 
     * @return    void
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @version   SVN: $Id$
     * @copyright 2014 INGENEO S.A.S.     
     * @access    public     
     */
    public function __construct()
    {
        
    }

    /**
     * Funcion desctructora 
     * 
     * @return    void
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @version   SVN: $Id$
     * @copyright 2014 INGENEO S.A.S. 
     * @access    public     
     */
    public function __destruct()
    {
        
    }

    /**
     * Metodo para la creacion de mensaje 
     * al validar un archivo
     * 
     * @param int    $line  Linea del registro
     * @param string $field Campo
     * @param string $msg   Mensaje
     * 
     * @return string
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2014 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function makeMsg($line, $field, $msg)
    {
        return '<strong>Fila: </strong>' . $line
            . ' <strong>Campo: </strong>' . $field
            . ' <strong>Msg: </strong>' . $msg . ' <br/>';
    }

    /**
     * Metodo para la descarga de archivos en fomato xlsx
     * El formato de los datos es array(
     *  array(
     *      campo=>valor
     *  )
     *  array(
     *      campo=>valor
     *  )
     * )
     * 
     * @param string $name      Nombre del archivo
     * @param array  $headers   Cabeceras del archivo
     * @param array  $arrayData Datos del archivo
     * 
     * @return boolean
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2014 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function downFileExcel($name, $headers, $arrayData)
    {
        if(count($arrayData) > 0 && count($headers) > 0) {
            $nameFile = (!empty($name)) ? $name : 'Catalogo Items';
            $objPHPExcel = new PHPExcel();
            array_unshift($arrayData, $headers);
            $objPHPExcel->getActiveSheet()->fromArray($arrayData);
            $objPHPExcel->getActiveSheet()->setTitle($nameFile);
            $objPHPExcel->setActiveSheetIndex(0);
            //Para descargar en xlsx
            header('Content-Type: application/octet-stream');
            header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet; charset=UTF-8');
            header('Content-Disposition: attachment;filename="' . $nameFile . '.xlsx"');
            header('Cache-Control: max-age=0');
            $objWriter = new PHPExcel_Writer_Excel2007($objPHPExcel);
            $objWriter->setOffice2003Compatibility(true);
            //Para descargar en xls
            //header('Content-Type: application/vnd.ms-excel');
            //header('Content-Disposition: attachment;filename="'.$nameFile.'.xls"');
            //$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');            
            $objWriter->save('php://output');
            Yii::app()->end();
        }
        return false;
    }

    /**
     * Metodo para la descarga de archivos en fomato txt
     * El formato de los datos es array(
     *  array(
     *      campo=>valor
     *  )
     *  array(
     *      campo=>valor
     *  )
     * )
     * 
     * @param string $name      Nombre del archivo
     * @param array  $headers   Cabeceras del archivo
     * @param array  $arrayData Datos del archivo
     * 
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2014 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function downFileText($name, $headers, $arrayData)
    {
        if(count($arrayData) > 0 && count($headers) > 0) {
            ini_set("auto_detect_line_endings", true);
            $nameFile = (!empty($name)) ? $name : 'Catalogo Items';
            header("Content-language: es");
            header('Cache-Control: no-store, no-cache, must-revalidate');
            header('Cache-Control: pre-check=0, post-check=0, max-age=0');
            header('Pragma: no-cache');
            header('Expires: 0');
            header('Content-Transfer-Encoding: none');
            header('Content-Type: text/plain');
            header('Last-Modified: ' . date('D, d M Y H:i:s'));
            header('Content-Disposition: attachment; filename="' . $nameFile
                . ".txt");
            $outstream = fopen("php://output", 'w');
            fputcsv($outstream, $headers, ";", "\"");
            foreach($arrayData as $value) {
                $out = array();
                foreach($headers as $key => $header) {
                    if(isset($value[$key])) {
                        $data = str_replace("\n", "<br>", $value[$key]);
                        $data = str_replace("\r", "<br>", $data);
                        $data = str_replace("\t", "<br>", $data);
                        $data = str_replace("&nbsp;", ' ', $data);
                    } else {
                        $data = '';
                    }
                    $out[] = strip_tags($data);
                }
                if(!empty($out) && count($out)>0){
                    fputcsv($outstream, $out, ";");
                }
            }
            unset($arrayData);
            fclose($outstream);
            Yii::app()->end();
        }
    }

}

?>
