<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\InOut;

/**
 * InOutSearch represents the model behind the search form of `app\models\InOut`.
 */
class InOutSearch extends InOut
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['id'], 'integer'],
            [['id_co', 'name_co', 'type', 'id_cia', 'type_created', 'name_cia', 'nit', 'business_name', 'name_business_unit', 'id_cellar_in', 'name_cellar_in', 'id_cellar_out', 'name_cellar_out', 'number', 'description', 'status', 'date', 'created', 'created_by', 'modified', 'modified_by'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = InOut::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'date' => $this->date,
            'created' => $this->created,
            'modified' => $this->modified,
        ]);

        $query->andFilterWhere(['like', 'id_co', $this->id_co])
            ->andFilterWhere(['like', 'type', $this->type])
            ->andFilterWhere(['like', 'type_created', $this->type_created])
            ->andFilterWhere(['like', 'name_co', $this->name_co])
            ->andFilterWhere(['like', 'id_cia', $this->id_cia])
            ->andFilterWhere(['like', 'name_cia', $this->name_cia])
            ->andFilterWhere(['like', 'name_business_unit', $this->name_business_unit])
            ->andFilterWhere(['like', 'nit', $this->nit])
            ->andFilterWhere(['like', 'business_name', $this->business_name])
            ->andFilterWhere(['like', 'id_cellar_in', $this->id_cellar_in])
            ->andFilterWhere(['like', 'name_cellar_in', $this->name_cellar_in])
            ->andFilterWhere(['like', 'id_cellar_out', $this->id_cellar_out])
            ->andFilterWhere(['like', 'name_cellar_out', $this->name_cellar_out])
            ->andFilterWhere(['like', 'number', $this->number])
            ->andFilterWhere(['like', 'description', $this->description])
            ->andFilterWhere(['like', 'status', $this->status])
            ->andFilterWhere(['like', 'created_by', $this->created_by])
            ->andFilterWhere(['like', 'modified_by', $this->modified_by]);

        return $dataProvider;
    }
}
