<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\InventoryType;

/**
 * InventoryTypeSearch represents the model behind the search form of `app\models\InventoryType`.
 */
class InventoryTypeSearch extends InventoryType
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['id'], 'integer'],
            [['id_cia', 'name_cia', 'id_group_co', 'name_group_co', 'name', 'created', 'created_by', 'modified', 'modified_by'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = InventoryType::find();
        $this->load($params);
        // add conditions that should always apply here

        if(!empty($this->id_group_co)){
            $query->andWhere(['in', 'id_group_co', $this->id_group_co]);
        }else{
            $query->andWhere('id_group_co IS NULL');
        }

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'pagination' => [
                'pageSize' => 20,
            ],
        ]);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere(['like', 'id_cia', trim($this->id_cia)])
            ->andFilterWhere(['like', 'name_cia', trim($this->name_cia)])
            ->andFilterWhere(['like', 'name_group_co', trim($this->name_group_co)])
            ->andFilterWhere(['like', 'name', trim($this->name)])
            ->andFilterWhere(['like', 'created_by', trim($this->created_by)])
            ->andFilterWhere(['like', 'modified_by', trim($this->modified_by)]);
        return $dataProvider;
    }
}
