<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "param".
 *
 * @property int $id
 * @property string $key
 * @property string $value
 * @property string $description
 */
class Param extends \yii\db\ActiveRecord
{
    const DELETED_SI = 'SI';
    const DELETED_NO = 'NO';
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'param';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['key', 'value', 'description'], 'required'],
            [['value', 'description', 'deleted'], 'string'],
            [['key'], 'string', 'max' => 45],
            [['key'], 'unique'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => Yii::t('app', 'ID'),
            'key' => Yii::t('app', 'Key'),
            'value' => Yii::t('app', 'Value'),
            'description' => Yii::t('app', 'Description'),
            'deleted' => Yii::t('app', 'Deleted'),
        ];
    }
}
