<?php

namespace app\models;

use Yii;
use app\models\User;
use app\models\Configpdv;
use yii\helpers\ArrayHelper;

/**
 * This is the model class for table "usr_pdv".
 *
 * @property int $id
 * @property int $id_user
 * @property string $code_pdv
 * @property string $name_pdv
 * @property string $id_cia
 * @property string $name_cia
 * @property string $id_group_co
 * @property string $name_group_co
 * @property string $id_co
 * @property string $name_co
 * @property User $user
 */
class Usrpdv extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'usr_pdv';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            ['id_user', 'unique','message' => 'El Usuario ya tiene PDV relacionados'],
            [['id_user', 'code_pdv', 'name_pdv', 'id_cia', 'name_cia', 'id_group_co', 'name_group_co', 'id_co', 'name_co'], 'required'],
            [['id_user'], 'integer'],
            [['code_pdv', 'name_pdv', 'name_cia', 'name_group_co', 'id_group_co', 'id_co', 'name_co'], 'safe'],
            [['id_cia'], 'string', 'max' => 45],
            [['id_user'], 'exist', 'skipOnError' => true, 'targetClass' => User::className(), 'targetAttribute' => ['id_user' => 'id']],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => Yii::t('app', 'ID'),
            'id_user' => Yii::t('app', 'User ID'),
            'code_pdv' => Yii::t('app', 'Config Pdv ID'),
            'name_pdv' => Yii::t('app', 'Config Pdv ID'),
            'id_cia' => Yii::t('app', 'Id Cia'),
            'name_cia' => Yii::t('app', 'Name Cia'),
            'id_group_co' => Yii::t('app', 'Id Group Co'),
            'name_group_co' => Yii::t('app', 'Name Group Co'),
            'id_co' => Yii::t('app', 'Id Co'),
            'name_co' => Yii::t('app', 'Name Co'),
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getUser()
    {
        return $this->hasOne(User::className(), ['id' => 'id_user']);
    }

    /**
     * Retorna el listado de ls compañias relacionadas en PDV
     * @return array
     */
    public function getCiasDrop()
    {
        $cias = Configpdv::find()->groupBy('name_cia')->all();
        foreach ($cias as $value) {
            $value->name_cia = $value->id_cia . ' - ' . $value->name_cia;
        }
        return ArrayHelper::map($cias, 'id_cia', 'name_cia');
    }
}
