<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use yii\web\NotFoundHttpException;

/**
 * InventoryDetailSearch represents the model behind the search form of `app\models\CalculatorSecondaryItems`.
 */
class CalculatorSecondaryItemsSearch extends CalculatorSecondaryItems
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['id', 'id_item'], 'integer'],
            [['id_item', 'code', 'description', 'equivalence', 'code_unity', 'created'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = CalculatorSecondaryItems::find();

        // add conditions that should always apply here
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'sort' => [
                'defaultOrder' => [
                    'code' => SORT_ASC,
                ]
            ],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            return $dataProvider;
        }

        $query->andFilterWhere(['like', 'id', $this->id])
            ->andFilterWhere(['like', 'id_item', $this->id_item])
            ->andFilterWhere(['like', 'code', $this->code])
            ->andFilterWhere(['like', 'description', $this->description])
            ->andFilterWhere(['like', 'equivalence', $this->equivalence])
            ->andFilterWhere(['like', 'code_unity', $this->code_unity])
            ->andFilterWhere(['like', 'created', $this->created]);
        return $dataProvider;
    }
}
