<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Configpdv;

/**
 * ConfigpdvSearch represents the model behind the search form of `app\models\Configpdv`.
 */
class ConfigpdvSearch extends Configpdv
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['id'], 'integer'],
            [['code_pdv', 'name_pdv', 'id_co', 'name_co',
                'id_cellar_in', 'name_cellar_in', 'name_group_co', 'id_cellar_out', 'name_cellar_out',
                'created', 'created_by', 'modified', 'modified_by', 'id_cia', 
                'name_cia'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Configpdv::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'created' => $this->created,
            'modified' => $this->modified,
        ]);

        $query->andFilterWhere(['like', 'code_pdv', trim($this->code_pdv)])
            ->andFilterWhere(['like', 'name_pdv', trim($this->name_pdv)])
            ->andFilterWhere(['like', 'id_cia', trim($this->id_cia)])
            ->andFilterWhere(['like', 'name_cia', trim($this->name_cia)])
            ->andFilterWhere(['like', 'id_co', trim($this->id_co)])
            ->andFilterWhere(['like', 'name_co', trim($this->name_co)])
            ->andFilterWhere(['like', 'id_cellar_in', trim($this->id_cellar_in)])
            ->andFilterWhere(['like', 'name_cellar_in', trim($this->name_cellar_in)])
            ->andFilterWhere(['like', 'id_cellar_out', trim($this->id_cellar_out)])
            ->andFilterWhere(['like', 'name_cellar_out', trim($this->name_cellar_out)])
            ->andFilterWhere(['like', 'created_by', trim($this->created_by)])
            ->andFilterWhere(['like', 'modified_by', trim($this->modified_by)]);

        return $dataProvider;
    }
}
