<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\InventoryDetail;

/**
 * InventoryDetailSearch represents the model behind the search form of `app\models\InventoryDetail`.
 */
class InventoryDetailSearch extends InventoryDetail
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['id', 'difference_amount', 'id_inventory', 'id_reference', 'id_usuario'], 'integer'],
            [['notes', 'difference_price', 'reason', 'created', 'created_by', 'modified', 'modified_by'], 'safe'],
            [['counting_1', 'counting_2'], 'number'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = InventoryDetail::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere(['like', 'id_inventory', $this->id_inventory])
            ->andFilterWhere(['like', 'id_reference', $this->id_reference])
            ->andFilterWhere(['like', 'id_usuario', $this->id_usuario])
            ->andFilterWhere(['like', 'notes', $this->notes])
            ->andFilterWhere(['like', 'difference_price', $this->difference_price])
            ->andFilterWhere(['like', 'reason', $this->reason])
            ->andFilterWhere(['like', 'created_by', $this->created_by])
            ->andFilterWhere(['like', 'modified_by', $this->modified_by]);
        return $dataProvider;
    }
}
