<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;

/**
 * InventoryTypeSearch represents the model behind the search form of `app\models\InventoryTypeReferences`.
 */
class InventoryTypeReferencesSearch extends InventoryTypeReferences
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['id', 'id_inventory_type'], 'integer'],
            [['id', 'reference', 'description', 'name_category', 'measured_unit', 'margin_loss'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = InventoryTypeReferences::find();
        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        $query->andFilterWhere(['=', 'id_inventory_type', trim($this->id_inventory_type)])
            ->andFilterWhere(['like', 'reference', trim($this->reference)])
            ->andFilterWhere(['like', 'description', trim($this->description)])
            ->andFilterWhere(['like', 'name_category', trim($this->name_category)])
            ->andFilterWhere(['like', 'measured_unit', trim($this->measured_unit)])
            ->andFilterWhere(['like', 'margin_loss', trim($this->margin_loss)]);
        $query->orderBy('description');
        return $dataProvider;
    }
}
