<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Requisitiondetail;

/**
 * RequisitiondetailSearch represents the model behind the search form of `app\models\Requisitiondetail`.
 */
class RequisitiondetailSearch extends Requisitiondetail
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['id', 'requisition_id'], 'integer'],
            [['reference', 'description', 'category', 'created', 'created_by', 'modified', 'modified_by'], 'safe'],
            [['quantity', 'unid_exist'], 'number'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Requisitiondetail::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'quantity' => $this->quantity,
            'unid_exist' => $this->unid_exist,
            'created' => $this->created,
            'modified' => $this->modified,
            'requisition_id' => $this->requisition_id,
        ]);

        $query->andFilterWhere(['like', 'reference', $this->reference])
            ->andFilterWhere(['like', 'description', $this->description])
            ->andFilterWhere(['like', 'category', $this->category])
            ->andFilterWhere(['like', 'created_by', $this->created_by])
            ->andFilterWhere(['like', 'modified_by', $this->modified_by]);

        return $dataProvider;
    }
}
