<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Usrpdv;

/**
 * UsrpdvSearch represents the model behind the search form of `app\models\Usrpdv`.
 */
class UsrpdvSearch extends Usrpdv
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['id', 'id_user'], 'integer'],
            [['id', 'name_cia', 'name_pdv', 'name_group_co', 'name_co'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Usrpdv::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere(['like', 'name_cia', trim($this->name_cia)])
            ->andFilterWhere(['like', 'name_pdv', trim($this->name_pdv)])
            ->andFilterWhere(['like', 'name_group_co', trim($this->name_group_co)])
            ->andFilterWhere(['like', 'name_co', trim($this->name_co)])
            ->andFilterWhere(['=', 'id_user', trim($this->id_user)]);

        return $dataProvider;
    }
}
