<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use kartik\select2\Select2;
use yii\web\JsExpression;
use yii\helpers\Url;
use kartik\depdrop\DepDrop;


/* @var $this yii\web\View */
/* @var $model app\models\InventoryType */
/* @var $form yii\widgets\ActiveForm */

$type = $model->isNewRecord ? '' : $model->name;
$id_model  = $model->isNewRecord ? '' : $model->id;
$references = ($model->isNewRecord || empty($references) == TRUE) ? [0 => ['code' => '', 'description' => '', 'equivalence' => '', 'code_unity' => '']] : $references;
?>

<div class="calculate-form box box-solid">
    <div class="box-body">
        <?php $form = ActiveForm::begin([
            'id' => 'calculator'
        ]); ?>

        <?= $form->field($model, 'name')->textInput(['maxlength' => true]) ?>

        <?php echo $form->field($model, 'code_type')->widget(Select2::classname(), [
            'data' => $types,
            'value' => $type,
            'id' => 'select-type',
            'options' => [
                'placeholder' => 'Seleccione...',
            ],
            'theme' => Select2::THEME_DEFAULT
        ]); ?>

        <?= $form->field($model, 'quantity_liters')->textInput(['maxlength' => true, 'type' => 'number', 'step' => 'any']) ?>

        <?= $form->field($model, 'quantity_grams')->textInput(['maxlength' => true, 'type' => 'number', 'step' => 'any']) ?>

        <input type="hidden" id="id_calculate" value="<?php echo $id_model; ?>">

        <?php echo $this->render(
            '_formReferences.php', [
                'types' => $types,
                'measurementUnits' => $measurementUnits,
                'references' => $references,
                'model' => $model
            ]
        ) ?>

        <div class="form-group">
            <?php echo Html::submitButton(Yii::t('app', 'Save'), ['class' => 'btn btn-success btn-save']) ?>
            <?php echo Html::a(Yii::t('app', 'Cancel'), ['index'], ['class' => 'btn btn-default']) ?>
        </div>

        <?php ActiveForm::end(); ?>
    </div>
</div>
