<?php

use yii\helpers\Html;
use kartik\grid\GridView;

/* @var $this yii\web\View */
/* @var $searchModel app\models\ConfigpdvSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = Yii::t('app', 'Configpdvs');
$this->params['breadcrumbs'][] = $this->title;

?>
<div class="configpdv-index box box-solid">
    <div class="box-body">

        <p>
        <?= Html::a(Yii::t('app', 'Create Configpdv'), ['create'], ['class' => 'btn btn-success']) ?>
    </p>

    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'responsive'=>true,
        'columns' => [
            'name_cia',
            'code_pdv',
            'name_pdv',
            'name_group_co',
            'name_co',
            'name_cellar_in',
            'name_cellar_out',
            [
                'attribute' => 'multi_ubicacion',
                'value' => function($model){
                    return $model->multi_ubicacion == 1 ? 'Si' : 'No';
                }
            ],
            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>
    </div>
</div>
