<?php
    use yii\helpers\Url;
?>
<script>
    function initReady(){
        let trackChange = function(element) {
            let observer = new MutationObserver(function(mutations, observer) {
                if(mutations[0].attributeName == "value") {
                    $(element).trigger("change");
                    getCategories();
                }
            });
            observer.observe(element, {
                attributes: true
            });
        }
        trackChange($("#inventorytype-name_cia")[0]);

        $("#btn-succes-id").on("click", function (e) {
            $('#error-references').hide().html('');
            $('#error-list-categories').hide().html('');
            let id_type_inventory = $("#id_inventory_type").val();
            e.preventDefault();

            if($("#inventorytype-name").val() != ''){
                $.ajax( {
                    cache: false,
                    type: "POST",
                    url: '<?php echo Url::to(['inventory-type/validate-type']); ?>',
                    data: {
                        name: $("#inventorytype-name").val(),
                        group: $("#inventorytype-name_group_co").val(),
                        id_type_inventory: id_type_inventory
                    },
                    beforeSend: function(){
                        showLoading();
                    },
                    success: function(response) {
                        if(response.status == 'ERROR'){
                            hideLoading();
                            $('#error-references').html(response.message).show();
                            $(window).scrollTop($("#error-references").offset().top-200);
                            return false;
                        }else{
                            let tam = $(".selected-reference").length;
                            let int = 0;
                            let selected = 0;

                            $('.selected-reference:checked').each(function() {
                                selected++;
                            })

                            if(selected > 0) {
                                $(".selected-reference").each(function(index) {
                                    if($(this).prop('checked') == false) {
                                        $(this).parent().parent('.tr-selected').remove()
                                    }
                                    int++;
                                });

                                if(tam == int && int > 0) {
                                    $('#inventory-type').submit();
                                    return true;
                                }
                            }else if(selected == 0) {
                                hideLoading();
                                if(window.location.href.indexOf("create") != '-1'){
                                    $('#error-references').html('Debe existir mínimo una Referencia habilitada.').show();
                                    $(window).scrollTop($("#error-references").offset().top - 200);
                                }
                                return false;
                            }
                            return false;
                        }
                    },
                    error: function () {
                        hideLoading();
                        $('#list-categories').show();
                        $('#error-list-categories').show().text('Error de conexión.');
                        return false;
                    }
                });
            }
            return false;
        });
    }

    $(document).ready(initReady());

    function getCategories(){
        $('#error-list-categories').hide().html('');
        $('#list-info-categories').hide().html('');

        if($("#inventorytype-name_cia").val() != '') {
            let id_cia = $("#inventorytype-id_cia").val();
            let id_type_inventory = $("#id_inventory_type").val();
            let url = '<?php echo Url::to(['inventory-type/get-categories']); ?>';

            $.ajax({
                url: url,
                type: "GET",
                data: {"id_cia": id_cia, "id_type_inventory": id_type_inventory},
                beforeSend: function(){
                    showLoading();
                    $('#error-list-categories').hide().text('');
                },
                success: function(result){
                    $('#list-categories').show();
                    if(typeof result.status != 'undefined' || result.status == 'ERROR'){
                        $('#error-list-categories').show().text(result.error);
                        $(window).scrollTop($("#error-list-categories").offset().top-200);
                    }else{
                        $('#list-info-categories').show().html(result);
                    }
                    if(id_type_inventory != ''){
                        $('.btn-save').removeAttr('disabled');
                    }
                    hideLoading();
                    return false;
                },
                error: function () {
                    hideLoading();
                    $('#list-categories').show();
                    $('#error-list-categories').show().text('Error de conexión.');
                }
            });
        }else{
            hideLoading();
            $('#list-info-categories').hide().html('');
            $('.btn-save').attr('disabled', 'disabled');
        }
        return false;
    }

    /**
     * Muestra el icono de cargando
     * @returns {undefined}
     */
    function showLoading(){
        $("#div-type-inventory").append('<div class="overlay"><i class="fa fa-refresh fa-spin"></i></div>');
    }

    /**
     * Esconde el icono de cargando
     * @returns {undefined}
     */
    function hideLoading(){
        $(".overlay").remove();
    }
</script>

