<?php

use yii\helpers\Html;
use kartik\grid\GridView;

/* @var $this yii\web\View */
/* @var $searchModel app\models\InventoryTypeSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = Yii::t('app', 'Inventory Type');
$this->params['breadcrumbs'][] = $this->title;

?>
    <div id="div-index" class="configpdv-index box box-solid">
        <div class="box-body">
            <p>
                <?= Html::a(Yii::t('app', 'Create Inventory Type'), ['create'], ['class' => 'btn btn-success']) ?>
            </p>

            <?= GridView::widget([
                'dataProvider' => $dataProvider,
                'filterModel' => $searchModel,
                'responsive' => true,
                'columns' => [
                    'name_cia',
                    'name_group_co',
                    'name',
                    'created_by',
                    ['class' => 'yii\grid\ActionColumn',
                        'template' => '{view}{update}{delete}{update-siesa}',
                        'buttons' => [
                            'delete' => function ($url, $model) {
                                return Html::a('<span class="glyphicon glyphicon-trash"></span>', $url, [
                                    'class' => '',
                                    'data' => [
                                        'confirm' => Yii::t('app', 'Are you absolutely sure? You will lose all information about this type of inventory, related inventories, counts and planning.'),
                                        'method' => 'post',
                                    ],
                                ]);
                            },
                            'update-siesa' => function ($url, $model) {
                                return Html::a('<span class="glyphicon glyphicon-repeat"></span>', $url, [
                                    'class' => 'reload-siesa',
                                    'title' => 'Actualizar información de Referencias con SIESA'
                                ]);
                            }
                        ]
                    ],

                ],
            ]); ?>
        </div>
    </div>

<?php echo $this->render(
    '_index.php'
) ?>