<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use kartik\grid\GridView;
use kartik\export\ExportMenu;

/* @var $this yii\web\View */
/* @var $model app\models\InventoryType */

$this->title = $model->name;
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Inventory Type'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;

$columns = [
    ['class' => 'yii\grid\SerialColumn'],
    'referencee',
    'description',
    'name_category',
    'measured_unit',
    'unit_price',
    'name_provider',
    'current_inventory',
    'margin_loss',
];

//Listas sortable
$gridColumns = $columns;
?>

<div class="inventorytype-view box box-solid">
    <div class="box-header with-border">
        <?= Html::a(Yii::t('app', 'Update'), ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
        <?= Html::a(Yii::t('app', 'Cancel'), ['index', 'id' => $model->id], ['class' => 'btn btn-default']) ?>
    </div>
    <div class="box-body">
        <?= DetailView::widget([
            'model' => $model,
            'attributes' => [
                'name',
                'name_group_co',
                'created_by',
                'created',
            ],
        ]) ?>
    </div>
</div>

<div class="inventory-view box box-solid">
    <?php if(empty($dataProvider) == FALSE): ?>
        <?php echo $this->render(
            '_references_view', [
            'model' => $model,
            'dataProvider' => $dataProvider,
            'searchModel' => $searchModel
        ]); ?>
    <?php endif; ?>
</div>
