<?php
    use yii\helpers\Url;
?>

<script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>

<script>
    $(document).ready(function () {
        $('#pdv').change(function () {
            $('.btn-planning').click();
        })

        $('#month').change(function () {
            $('.btn-planning').click();
        })

        $("#dialog-duplicate").dialog({
            autoOpen: false,
            height: 'auto',
            width: 'auto',
            modal: true,
            buttons: {
                "<?php echo Yii::t('app', 'Duplicate') ?>": function() {
                    if($("#pdvs-list").val() != '' && $("#month").val() != '' && $("#pdv").val() != '') {
                        let pdvs = $("#pdvs-list").val();
                        pdvs = pdvs.toString();
                        let pdv = $("#pdv").val();
                        let month = $("#month").val();
                        let url = '<?php echo Url::to(['planning/get-duplicate-events']); ?>';

                        $.ajax({
                            url: url,
                            type: "GET",
                            data: {"pdvs": pdvs, "pdv": pdv, "month": month},
                            beforeSend: function(){
                                $('#error').hide();
                                $('#success').hide();
                                $('#error').text('');
                                $('#success').text('');
                            },
                            success: function(result){
                                $("#dialog-duplicate").dialog("close");
                                $("#pdvs-list").multiselect('clearSelection');
                                if(result.status == 'ERROR'){
                                    $('#success').text('');
                                    $('#success').hide();
                                    $('#error-dup').show();
                                    $('#error-dup').text(result.error);
                                    return false;
                                }else if(result.status == 'SUCCESS'){
                                    $('#success').show();
                                    $("#success").html(result.message);
                                    return false;
                                }
                            }
                        });

                    }
                },
                "<?php echo Yii::t('app', 'Close') ?>": function() {
                    $(this).dialog("close");
                }
            }
        });

        $('.btn-duplicate').click(function () {
            $(".selected").show().removeClass('selected');
            let pdv = $("#pdv option:selected").text();
            $('#error-dup').hide().text('');
            $('#success').hide().text('');
            $("label[title='"+pdv+"']").hide().addClass('selected');
            $("#dialog-duplicate").dialog("open");
        })

        $('.btn-planning').click(function () {
            $('#error-dup').hide().text();
            $('#success').hide().text('');

            if($("#pdv").val() != '' && $("#month").val() != '') {
                $("#pdvs-list").multiselect('clearSelection');
                let pdv = $("#pdv").val();
                let month = $("#month").val();
                let url = '<?php echo Url::to(['planning/get-events-month']); ?>';

                $.ajax({
                    url: url,
                    type: "GET",
                    data: {"pdv": pdv, "month": month},
                    beforeSend: function(){
                        $('#error').hide();
                        $("#div-calendar").addClass('display-none');
                        $("#dialog-calendar").dialog("destroy");
                        showLoading();
                        $('.btn-duplicate').hide();
                        $('#div-calendar').html('');
                    },
                    success: function(result){
                        hideLoading();

                        if(typeof result.status != 'undefined' || result.status == 'ERROR'){
                            $('#error').show().text(result.error);
                            return false;
                        }
                        $('.btn-duplicate').removeClass('display-none').show();
                        $('#div-calendar').show().html(result);
                        return false;
                    },
                    error: function(){
                        hideLoading();
                    },
                });
            }
        })
    });

    /**
     * Muestra el icono de cargando
     * @returns {undefined}
     */
    function showLoading(){
        $("#div-calendar-load").append('<div class="overlay"><i class="fa fa-refresh fa-spin"></i></div>');
    }

    /**
     * Esconde el icono de cargando
     * @returns {undefined}
     */
    function hideLoading(){
        $(".overlay").remove();
    }
</script>

