<?php

use yii\helpers\Html;
use wbraganca\multiselect\MultiSelectWidget;

$this->title = Yii::t('app', 'Planning'); ?>

<div id="dialog-duplicate" class="display-none">
    <?php if(empty($pdv_list) == FALSE): ?>
        <h4 class="text-center font-weight-bold"><?php echo Yii::t('app', 'Please select PDVs'); ?></h4>
        <?php echo MultiSelectWidget::widget([
            'options' => [
                'multiple' => 'multiple',
                'class' => 'form-control',
                'id' => 'pdvs-list',
            ],
            'clientOptions' => [
                'numberDisplayed' => 1,
                'nonSelectedText' => 'Ninguno seleccionada',
                'nSelectedText' => 'seleccionados',
                'allSelectedText' => 'Todos seleccionados',
            ],
            'data' => $pdv_list,
            'name' => 'pdv_list_name'
        ]) ?>
    <?php else: ?>
        <h4 class="text-center font-weight-bold"><?php echo Yii::t('app', 'There are no PDV'); ?></h4>
    <?php endif; ?>
</div>


<div id="div-calendar-load"  class="box box-solid">
    <div class="box-body">
        <?php if(empty($pdv_list) == FALSE): ?>
        <div class="col-md-6">
            <label class="text-center margin-t-15"><?php echo Yii::t('app', 'PDV'); ?></label>
            <?php echo Html::dropDownList('', [], $pdv_list, ['class' => 'form-control', 'id' => 'pdv']); ?>
        </div>
        <div class="col-md-6">
            <label class="text-center margin-t-15"><?php echo Yii::t('app', 'Month'); ?></label>
            <?php echo Html::dropDownList('', [], $months, ['class' => 'form-control', 'id' => 'month']); ?>
        </div>

        <div class="col-md-12 margin-t-15">
            <div id="error-dup" class="alert alert-danger display-none" role="alert"></div>

            <div id="success" class="alert alert-success display-none" role="alert"></div>

            <?= Html::a(Yii::t('app', 'Search'), null, ['class' => 'btn btn-success btn-planning']) ?>
            <?= Html::a(Yii::t('app', 'Duplicate'), null, ['class' => 'btn btn-success btn-duplicate display-none']) ?>
        </div>
        <?php else: ?>
        <div class="col-md-12">
            <h4 class="text-center font-weight-bold margin-t-15"><?php echo Yii::t('app', 'There are no PDV'); ?></h4>
        </div>
        <?php endif; ?>
    </div>

    <div id="div-calendar" class="display-none"></div>

    <div id="error" class="alert alert-danger display-none" role="alert"></div>
</div>

<?php echo $this->render(
    '_validate.php'
) ?>


