<?php

use app\models\ReportsDynamic;
use yii\helpers\Html;
use kartik\grid\GridView;

/* @var $this yii\web\View */
/* @var $searchModel app\models\ReportsSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = Yii::t('app', 'Reportes');
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="reportes-index box box-solid">
    
    <div class="box-header with-border">
        <p>
            <?= Html::a('<i class="fa fa-plus"></i> ' 
                    . Yii::t('app', 'Create Reports'), ['create'], ['class' => 'btn btn-success']) ?>
        </p>
    </div>  
    <div class="box-body">
    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'responsive'=>true,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            'name',
            [
                'attribute'=>'defaultParameters',
                'value' => function($data){
                    $reportDynamic = new ReportsDynamic();
                    $temp = $reportDynamic->getTempList($data->defaultParameters);
                    $result = array_column($temp, 'content');                    
                    return implode(', ', $result);
                }
            ],
            [
                'header' => 'Ver Reporte',                
                'format' => 'html',
                'contentOptions' => ['class' => 'text-center'],
                'value' => function($data){
                    return Html::a('<span class="fa fa-line-chart"></span>', ['update', 'id'=>$data->id], ['target'=>'_blank']);
                }
            ],
            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>
    </div>
</div>

