<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Configpdv */

$this->title = $model->name;
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Users SIESA'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="user-siesa-create-view box box-solid">
    <div class="box-body with-border">
        <?= Html::a(Yii::t('app', 'Update'), ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
        <?= Html::a(Yii::t('app', 'Delete'), ['delete', 'id' => $model->id], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => Yii::t('app', 'Are you sure you want to delete this item?'),
                'method' => 'post',
            ],
        ]) ?>
        <?= Html::a(Yii::t('app', 'Cancel'), ['index', 'id' => $model->id], ['class' => 'btn btn-default']) ?>
    </div>
    <div class="box-body">
    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'name',
            'username',
            'email',
            [
                'attribute' => 'status',
                'value' => function($model) use ($states){
                    return $states[$model['status']];
                }
            ],
            'created',
            'created_by'
        ],
    ]) ?>
    </div>
</div>
