<?php

use app\models\Param;
use yii\helpers\Html;
use yii\widgets\DetailView;
use kartik\grid\GridView;
use kartik\export\ExportMenu;

/* @var $this yii\web\View */
/* @var $model mdm\admin\models\User */


$this->title = $model->username;
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Users'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;

$controllerId = $this->context->uniqueId . '/';
$states = json_decode(Param::findOne(['key' => 'states_users'])->value, true);
?>

<div class="user-view box box-solid">

    <div class="box-header with-border">
        <?= Html::a(Yii::t('app', 'Update'), ['/user/update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
        <?= Html::a(Yii::t('app', 'Delete'), ['delete', 'id' => $model->id], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => Yii::t('app', 'Are you sure you want to delete this item?'),
                'method' => 'post'
            ],
        ]) ?>
        <?= Html::a(Yii::t('app', 'Cancel'), ['index', 'id' => $model->id], ['class' => 'btn btn-default']) ?>
    </div>
    <div class="box-body">
        <?=
        DetailView::widget([
            'model' => $model,
            'attributes' => [
                [
                    'label' => 'Nombre de Usuario',
                    'attribute'=>'username',
                    'value'=>function($data){
                        if(empty($data->username) == FALSE){
                            return $data->username;
                        }
                    }
                ],
                [
                    'label' => 'Correo electrónico',
                    'attribute'=>'username',
                    'value'=>function($data){
                        if(empty($data->email) == FALSE){
                            return $data->email;
                        }
                    }
                ],
                [
                    'label' => 'Creado por',
                    'attribute'=>'created_at',
                    'value'=>function($data){
                        if(empty($data->created_at) == FALSE){
                            return $data->created_at;
                        }
                    }
                ],
                [
                    'label' => 'Estado',
                    'attribute' => 'status',
                    'value' => function($model) use ($states){
                        return $states[$model['status']];
                    }
                ]
            ],
        ])
        ?>
    </div>
</div>


