<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use kartik\select2\Select2;
use yii\web\JsExpression;
use yii\helpers\Url;
use kartik\depdrop\DepDrop;

/* @var $this yii\web\View */
/* @var $model app\models\Usrpdv */
/* @var $form yii\widgets\ActiveForm */

$cia = $model->isNewRecord ? '' : $model->id_cia. ' - '.$model->name_cia;
$user = $model->isNewRecord ? '' : $model->id_user;

$pdv = [];
if(!$model->isNewRecord){
    $pdv[] = explode('-', $model->code_pdv);
}

$group = [];
if(!$model->isNewRecord){
    $group = explode('-', $model->id_group_co);
}

$co = [];
if(!$model->isNewRecord){
    $co = explode('-', $model->id_co);
}

?>

<div class="usrpdv-form box box-solid">
    <div class="box-body">
        <?php $form = ActiveForm::begin(); ?>

        <?php echo $form->field($model, 'id_cia')->widget(Select2::classname(), [
            'data' => $cias,
            'value' => $cia,
            'options' => [
                'placeholder' => 'Seleccione...',
            ],
            'theme' => Select2::THEME_DEFAULT,
            'pluginOptions' => [
                'allowClear' => true,
                'templateSelection' => new JsExpression('function (data) { '
                    . 'tmpText = data.text;'
                    . 'text = tmpText.split(" - ")[1];'
                    . '$("#usrpdv-name_cia").val(text); '
                    . 'return data.text; }'),
            ],
        ]); ?>

        <?php echo $form->field($model, 'name_cia')->hiddenInput()->label(false)->error(false) ?>

        <?php echo $form->field($model, 'code_pdv')->widget(DepDrop::classname(), [
            'type'=>DepDrop::TYPE_SELECT2,
            'select2Options'=>[
                'initValueText' => $pdv,
                'theme' => Select2::THEME_DEFAULT,
                'pluginOptions'=>[
                    'allowClear'=>true,
                    'multiple' => true,
                    'escapeMarkup' => new JsExpression('function (markup) {return markup; }'),
                    'templateResult' => new JsExpression('function(data) { return data.text; }'),
                    'templateSelection' => new JsExpression('function (data) { '
                        . 'tmpText = data.text;'
                        . 'text = tmpText.split(" - ")[1];'
                        . 'return data.text; }'),
                ],
            ],
            'pluginOptions'=>[
                'depends'=>['usrpdv-id_cia'],
                'placeholder' => 'Seleccione...',
                'loadingText' => 'Buscando Puntos de ventas...',
                'url' => Url::to(['generic/get-pdvs']),
                'params' => ['usrpdv-id_cia', 'usrpdv-id'],
                'initialize' => true,
            ]
        ]); ?>

        <?php echo $form->field($model, 'name_pdv')->hiddenInput()->label(false)->error(false) ?>

        <?php echo $form->field($model, 'id_group_co')->widget(DepDrop::classname(), [
            'type' => DepDrop::TYPE_SELECT2,
            'data' => $group,
            'select2Options'=>[
                'initValueText' => $group,
                'theme' => Select2::THEME_DEFAULT,
                'pluginOptions'=>[
                    'multiple' => true,
                    'allowClear'=>true,
                    'escapeMarkup' => new JsExpression('function (markup) {return markup; }'),
                    'templateResult' => new JsExpression('function(data) { return data.text; }'),
                    'templateSelection' => new JsExpression('function (data) { '
                        . 'tmpText = data.text;'
                        . 'text = tmpText.split(" - ")[1];'
                        . 'return data.text; }'),
                ],
            ],
            'pluginOptions'=>[
                'depends' => ['usrpdv-code_pdv'],
                'params' => ['usrpdv-id_cia', 'usrpdv-code_pdv', 'usrpdv-id'],
                'placeholder' => 'Seleccione...',
                'loadingText' => 'Buscando Grupos de Centros de Operaciones...',
                'url' => Url::to(['generic/get-groups']),
                'initialize' => true,
            ]
        ]); ?>

        <?php echo $form->field($model, 'name_group_co')->hiddenInput()->label(false)->error(false) ?>

        <?php echo $form->field($model, 'id_co')->widget(DepDrop::classname(), [
            'type'=>DepDrop::TYPE_SELECT2,
            'data'=> $co,
            'select2Options'=>[
                'initValueText' => $co,
                'theme' => Select2::THEME_DEFAULT,
                'pluginOptions'=>[
                    'multiple' => true,
                    'allowClear'=>true,
                    'escapeMarkup' => new JsExpression('function (markup) {return markup; }'),
                    'templateResult' => new JsExpression('function(data) { return data.text; }'),
                    'templateSelection' => new JsExpression('function (data) { '
                        . 'tmpText = data.text;'
                        . 'text = tmpText.split(" - ")[1];'
                        . 'return data.text; }'),
                ],
            ],
            'pluginOptions'=>[
                'depends'=>['usrpdv-id_group_co'],
                'params' => ['usrpdv-id_group_co', 'usrpdv-id_cia', 'usrpdv-code_pdv', 'usrpdv-id'],
                'placeholder' => 'Seleccione...',
                'loadingText' => 'Buscando Centros de Operaciones...',
                'url' => Url::to(['generic/get-list-co-group'])
            ]
        ]); ?>

        <?php echo $form->field($model, 'name_co')->hiddenInput()->label(false)->error(false) ?>

        <?php echo $form->field($model, 'id_user')->widget(Select2::classname(), [
            'data' => $users,
            'value' => $user,
            'options' => [
                'placeholder' => 'Seleccione...',
            ],
            'theme' => Select2::THEME_DEFAULT
        ]); ?>

        <?php echo $form->field($model, 'id')->hiddenInput()->label(false)->error(false) ?>

        <div class="form-group">
            <?php echo Html::submitButton(Yii::t('app', 'Save'), ['class' => 'btn btn-success']) ?>
            <?php echo Html::a(Yii::t('app', 'Cancel'), ['index'], ['class' => 'btn btn-default']) ?>
        </div>

        <?php ActiveForm::end(); ?>

    </div>
</div>

<script type="text/javascript">
    $(document).ready(function () {
        $("#usrpdv-code_pdv").change(function() {
            let pdv = [];

            $('#usrpdv-code_pdv :selected').each(function(index){
                pdv.push($(this).text());
            });

            if(pdv.length > 0){
                $("#usrpdv-name_pdv").val(pdv).text();
            }
        });

        $("#usrpdv-id_group_co").change(function() {
            let group_co = [];

            $('#usrpdv-id_group_co :selected').each(function(index){
                group_co.push($(this).text());
            });

            if(group_co.length > 0){
                $("#usrpdv-name_group_co").val(group_co).text();
            }
        });

        $("#usrpdv-id_co").change(function() {
            var co = [];

            $('#usrpdv-id_co :selected').each(function(index){
                co.push($(this).text());
            });

            if(co.length > 0){
                $("#usrpdv-name_co").val(co).text();
            }
        });
    })
</script>
