<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Usrpdv */

$this->title = $model->user->username;
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Usrpdvs'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="usrpdv-view box box-solid">
    <div class="box-header with-border">
        <?= Html::a(Yii::t('app', 'Update'), ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
        <?= Html::a(Yii::t('app', 'Delete'), ['delete', 'id' => $model->id], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => Yii::t('app', 'Are you sure you want to delete this item?'),
                'method' => 'post',
            ],
        ]) ?>
        <?= Html::a(Yii::t('app', 'Cancel'), ['index', 'id' => $model->id], ['class' => 'btn btn-default']) ?>
    </div>
    <div class="box-body">
    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'name_cia',
            [
                'attribute'=>'name_pdv',
                'value'=> function($model){
                    return str_replace(',', ', ', $model->name_pdv);
                }
            ],
            [
                'attribute'=>'name_group_co',
                'value'=> function($model){
                    return str_replace(',', ', ', $model->name_group_co);
                }
            ],
            [
                'attribute'=>'name_co',
                'value'=> function($model){
                    return str_replace(',', ', ', $model->name_co);
                }
            ],
            [
                'attribute'=>'id_user',
                'value'=> $model->user->username
            ]
        ],
    ]) ?>
    </div>
</div>
