<?php
use yii\helpers\Html;
use yii\widgets\ActiveForm;
use \app\models\CalculatorMainItems;
?>

<div class="margin-bottom">
    <h3 class="text-center"><?php echo Yii::t('app', 'Equivalences'); ?></h3>
</div>

<div class="no-padding table-responsive filterable">
    <table class="table table-bordered">
        <thead class="for">
        <tr>
            <th scope="col"><label><?php echo Yii::t('app', 'Code'); ?></label></th>
            <th scope="col"><label><?php echo Yii::t('app', 'Description'); ?></label></th>
            <th scope="col"><label><?php echo Yii::t('app', 'Equivalence'); ?></label></th>
            <th scope="col"><label><?php echo Yii::t('app', 'Name Unity'); ?></label></th>
            <th scope="col"></th>
        </tr>
        </thead>
        <tbody id="tbody-references">
            <?php $i = count($references)-1; ?>

            <?php foreach ($references as $key => $value): ?>

            <tr class="row-table row-<?php echo $key; ?>">
                <?php if(empty($value['id']) == FALSE): ?>
                    <input class="form-control required-references" type="hidden" name="Calculate_secondary[<?php echo $key; ?>][id]" value="<?php echo $value['id']; ?>">
                <?php endif; ?>
                <td>
                    <input class="form-control required-references" type="text " name="Calculate_secondary[<?php echo $key; ?>][code]" value="<?php echo $value['code']; ?>">
                </td>
                <td>
                    <input class="form-control required-references" type="text" name="Calculate_secondary[<?php echo $key; ?>][description]" value="<?php echo $value['description']; ?>">
                </td>
                <td>
                    <input class="form-control required-references" step="0.01" type="number" name="Calculate_secondary[<?php echo $key; ?>][equivalence]" value="<?php echo $value['equivalence']; ?>">
                </td>
                <td>
                    <?php echo Html::dropDownList("Calculate_secondary[".$key."][code_unity]", $value['code_unity'], $measurementUnits, ['class' => 'form-control']); ?>
                </td>
                <td class="text-center">
                    <?php $display = $model->code_type == CalculatorMainItems::TYPE_COMPOSED ? '' : 'display-none'; ?>

                    <?php echo Html::a(null, null, ['class' => "glyphicon glyphicon-plus add-reference $display"]) ?>
                    <?php echo Html::a(null, null, ['class' => "glyphicon glyphicon-minus remove-reference $display", 'data-key' => $key]) ?>
                </td>
            </tr>
            <?php endforeach; ?>

            <tr class="alert-references display-none">
                <td colspan="5" class="text-center">
                    <a class="glyphicon glyphicon-plus add-reference"></a> <?php echo Yii::t('app', 'Required Refences'); ?>
                </td>
            </tr>
        </tbody>
    </table>
    <input class="count-references" type="hidden" value="<?php echo $i; ?>">
</div>

<div class="form-group has-error">
    <div id="error-references" class="help-block" role="alert"></div>
</div>

<?php echo $this->render(
    '_references.php', [
            'measurementUnits' => $measurementUnits
    ]
) ?>
