<?php
use yii\helpers\Url;
?>

<script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>

<script>
    $(document).on( "click", "a.add-reference", function() {
        $(".alert-references").hide();
        $(".btn-save").removeAttr('disabled');
        let count = parseInt($('.count-references').val())+1;
        let units = <?php echo json_encode($measurementUnits); ?>;
        if(count >= 0){
            let html = '<tr class="row-table row-'+count+'">';
            html += '<td><input class="form-control required-references" type="text" name="Calculate_secondary['+count+'][code]"></td>';
            html += '<td><input class="form-control required-references" type="text" name="Calculate_secondary['+count+'][description]"></td>';
            html += '<td><input class="form-control required-references" type="number" step="any" name="Calculate_secondary['+count+'][equivalence]"></td>';
            html += '<td><select class="form-control" name="Calculate_secondary['+count+'][code_unity]"> ';
            $.each(units, function( key, value ) {
                html += '<option value="'+key+'">'+value+'</option>';
            });
            html += '</select></td>';
            html += '<td class="text-center"><a class="glyphicon glyphicon-plus add-reference"></a>';
            html += '<a class="glyphicon glyphicon-minus remove-reference" data-key="'+count+'"></a></td>';
            html += '</tr>';

            $("#tbody-references").append(html);
            $('.count-references').val(count);
        }
    })

    $(document).on("click", "a.remove-reference", function() {
        let remove = $(this).data('key');
        let exist_element = false;
        $(".row-"+remove).remove();

        $('.row-table').each(function(index,element){
            exist_element = true;
        });

        if(exist_element == false){
            $('.count-references').val(0);
            $('.alert-references').show();
            $(".btn-save").attr('disabled', 'disabled');
        }else{
            $('.alert-references').hide();
            $(".btn-save").removeAttr('disabled');
        }
    })

    $("#calculatormainitems-code_type").change(function () {
        if($("#calculatormainitems-code_type").val() != 'simple'){
            $(".add-reference").show();
            $(".remove-reference").show();
        }else{
            $('.row-table').each(function(index, element){
                if(index != 0){
                    $(this).remove();
                }
            });
            $(".add-reference").hide();
            $(".remove-reference").hide();
        }
    })

    $("#calculator").submit(function (event) {
        event.preventDefault();
        $('#error-references').hide().html('');
        let tam = $(".required-references").length;
        let int = 0;

        $(".required-references").each(function(index) {
            int++;
            if($(this).val() == ''){
                $('#error-references').show().html('Por favor ingrese todos los valores del Referencias.');
                $(this).addClass('border-error');
            }
        });
        if(tam == int){
            if($('#error-references').html() == '') {
                $.ajax( {
                    type: "POST",
                    url: $("#calculator").attr('action'),
                    data: $("#calculator").serialize(),
                    success: function(response) {
                        if(response.status == 'ERROR'){
                            $('#error-references').show().html(response.message);
                        }else if(response.status == 'SUCCESS'){
                            window.location.href = '<?php echo Url::to(['calculate/view/']); ?>&id='+response.id;
                        }
                    }
                } );
                return;
            }
        }
        return;
    })

    $(".required-references").on("click keyup", function () {
        $(".required-references").removeClass('border-error');
        $('#error-references').hide();
        $('#error-references').html('');;
    })
</script>