<?php

use yii\helpers\Html;
use kartik\grid\GridView;

/* @var $this yii\web\View */
/* @var $searchModel app\models\ConfigpdvSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = Yii::t('app', 'Calculate');
$this->params['breadcrumbs'][] = $this->title;

?>
<div class="calculate-index box box-solid">
    <div class="box-body">

        <p>
            <?= Html::a(Yii::t('app', 'Create Reference'), ['create'], ['class' => 'btn btn-success']) ?>
        </p>

        <?= GridView::widget([
            'dataProvider' => $dataProvider,
            'filterModel' => $searchModel,
            'responsive'=>true,
            'columns' => [
                'name',
                [
                    'attribute'=>'code_type',
                    'filter'=>$types,
                    'value' => function($data) use ($types){
                        return $types[$data->code_type];
                    }
                ],
                'quantity_grams',
                'quantity_liters',
                'created_by',
                'created',
                'modified_by',
                'modified',
                ['class' => 'yii\grid\ActionColumn'],
            ],
        ]); ?>
    </div>
</div>
