<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use kartik\select2\Select2;
use yii\web\JsExpression;
use yii\helpers\Url;
use kartik\depdrop\DepDrop;


/* @var $this yii\web\View */
/* @var $model app\models\Configpdv */
/* @var $form yii\widgets\ActiveForm */
$cia = $model->isNewRecord ? '' : $model->id_cia. ' - '.$model->name_cia;
$cellar_in = $model->isNewRecord ? '' : $model->id_cellar_in. ' - '.$model->name_cellar_in;
$cellar_out = $model->isNewRecord ? '' : $model->id_cellar_out. ' - '.$model->name_cellar_out;
$pdv = [];
if(!$model->isNewRecord){
  $pdv = [$model->code_pdv => $model->code_pdv.' - '.$model->name_pdv];   
}

$group = [];
if(!$model->isNewRecord){
    $group = [$model->id_group_co => $model->id_group_co.' - '.$model->name_group_co];
}

$co = [];
if(!$model->isNewRecord){
    $co = [$model->id_co => $model->id_co.' - '.$model->name_co];
}
?>

<div class="configpdv-form box box-solid">
    <div class="box-body">
        <?php $form = ActiveForm::begin(); ?>
        
        <?= $form->field($model, 'id_cia')->widget(Select2::classname(), [    
                'initValueText' => $cia, 
                'options' => [
                    'placeholder' => 'Seleccione compañia...',
                ],
                'theme' => Select2::THEME_DEFAULT,
                'pluginOptions' => [
                    'allowClear' => true,
                    'minimumInputLength' => 1,
                    'language' => [
                        'errorLoading' => new JsExpression("function () { return 'Buscando...'; }"),
                        'inputTooShort' => new JsExpression("function () { return 'Por favor ingrese 1 o más carácteres'; }"),
                        'searching' =>  new JsExpression("function () { return 'Buscando...'; }"),
                        'noResults' => 'No se encontraron resultados',
                    ],
                    'ajax' => [
                        'url' => $url = Url::to(['generic/get-cia']),
                        'dataType' => 'json',
                        'data' => new JsExpression('function(params) { return {q:params.term}; }')
                    ],
                    'escapeMarkup' => new JsExpression('function (markup) {return markup; }'),
                    'templateResult' => new JsExpression('function(data) { return data.text; }'),
                    'templateSelection' => new JsExpression('function (data) { '
                            . 'tmpText = data.text;'
                            . 'text = tmpText.split(" - ")[1];'
                            . '$("#configpdv-name_cia").val(text); '
                            . 'return data.text; }'),
                ],
                ]);?> 
        <?= $form->field($model, 'name_cia')->hiddenInput()->label(false)->error(false) ?>

        <?= $form->field($model, 'id_group_co')->widget(DepDrop::classname(), [
            'type'=>DepDrop::TYPE_SELECT2,
            'data'=>$group,
            'select2Options'=>[
                'initValueText' => $group,
                'theme' => Select2::THEME_DEFAULT,
                'pluginOptions'=>[
                    'allowClear'=>true,
                    'language' => [
                        'errorLoading' => new JsExpression("function () { return 'Buscando...'; }"),
                        'inputTooShort' => new JsExpression("function () { return 'Por favor ingrese 1 o más carácteres'; }"),
                        'searching' =>  new JsExpression("function () { return 'Buscando...'; }"),
                        'noResults' => 'No se encontraron resultados',
                    ],
                    'escapeMarkup' => new JsExpression('function (markup) {return markup; }'),
                    'templateResult' => new JsExpression('function(data) { return data.text; }'),
                    'templateSelection' => new JsExpression('function (data) { '
                        . 'tmpText = data.text;'
                        . 'text = tmpText.split(" - ")[1];'
                        . '$("#configpdv-name_group_co").val(text); '
                        . 'return data.text; }'),
                ],
            ],
            'pluginOptions'=>[
                'initialize' => true,
                'initDepends'=>['configpdv-id_cia'],
                'depends'=>['configpdv-id_cia'],
                'placeholder' => 'Seleccione...',
                'loadingText' => 'Buscando Grupos de Centros de Operaciones...',
                'url' => Url::to(['generic/get-groups'])
            ]
        ]); ?>

        <?= $form->field($model, 'name_group_co')->hiddenInput()->label(false)->error(false) ?>

        <?= $form->field($model, 'id_co')->widget(DepDrop::classname(), [
            'type'=>DepDrop::TYPE_SELECT2,
            'data'=>$co,
            'select2Options'=>[
                'initValueText' => $co,
                'theme' => Select2::THEME_DEFAULT,
                'pluginOptions'=>[
                    'allowClear'=>true,
                    'language' => [
                        'errorLoading' => new JsExpression("function () { return 'Buscando...'; }"),
                        'inputTooShort' => new JsExpression("function () { return 'Por favor ingrese 1 o más carácteres'; }"),
                        'searching' =>  new JsExpression("function () { return 'Buscando...'; }"),
                        'noResults' => 'No se encontraron resultados',
                    ],
                    'escapeMarkup' => new JsExpression('function (markup) {return markup; }'),
                    'templateResult' => new JsExpression('function(data) { return data.text; }'),
                    'templateSelection' => new JsExpression('function (data) { '
                        . 'tmpText = data.text;'
                        . 'text = tmpText.split(" - ")[1];'
                        . '$("#configpdv-name_co").val(text); '
                        . 'return data.text; }'),
                ],
            ],
            'pluginOptions'=>[
                'initialize' => true,
                'initDepends'=>['configpdv-id_cia', 'configpdv-id_group_co'],
                'depends'=>['configpdv-id_cia', 'configpdv-id_group_co'],
                'placeholder' => 'Seleccione...',
                'loadingText' => 'Buscando Centros de Operaciones...',
                'url' => Url::to(['generic/get-list-co-group'])
            ]
        ]); ?>

        <?= $form->field($model, 'name_co')->hiddenInput()->label(false)->error(false) ?>

        <?= $form->field($model, 'code_pdv')->widget(DepDrop::classname(), [
            'type'=>DepDrop::TYPE_SELECT2,
            'data'=>$pdv,
            'select2Options'=>[
                'initValueText' => $pdv,
                'theme' => Select2::THEME_DEFAULT,
                'pluginOptions'=>[
                    'allowClear'=>true,
                    'language' => [
                        'errorLoading' => new JsExpression("function () { return 'Buscando...'; }"),
                        'inputTooShort' => new JsExpression("function () { return 'Por favor ingrese 1 o más carácteres'; }"),
                        'searching' =>  new JsExpression("function () { return 'Buscando...'; }"),
                        'noResults' => 'No se encontraron resultados',
                    ],
                    'escapeMarkup' => new JsExpression('function (markup) {return markup; }'),
                    'templateResult' => new JsExpression('function(data) { return data.text; }'),
                    'templateSelection' => new JsExpression('function (data) { '
                        . 'tmpText = data.text;'
                        . 'text = tmpText.split(" - ")[1];'
                        . '$("#configpdv-name_pdv").val(text); '
                        . 'return data.text; }'),
                ],
            ],
            'pluginOptions'=>[
                'initialize' => true,
                'initDepends'=>['configpdv-id_cia'],
                'depends'=>['configpdv-id_cia'],
                'placeholder' => 'Seleccione...',
                'loadingText' => 'Buscando Puntos de venta...',
                'url' => Url::to(['generic/get-pdvs'])
            ]
        ]);
        ?>

        <?= $form->field($model, 'name_pdv')->hiddenInput()->label(false)->error(false) ?>

        <?= $form->field($model, 'id_cellar_in')->widget(Select2::classname(), [
            'initValueText' => $cellar_in,
            'options' => [
                'placeholder' => 'Seleccione Bodega...',
            ],
            'theme' => Select2::THEME_DEFAULT,
            'pluginOptions' => [
                'allowClear' => true,
                'minimumInputLength' => 1,
                'language' => [
                    'errorLoading' => new JsExpression("function () { return 'Buscando...'; }"),
                    'inputTooShort' => new JsExpression("function () { return 'Por favor ingrese 1 o más carácteres'; }"),
                    'searching' =>  new JsExpression("function () { return 'Buscando...'; }"),
                ],
                'ajax' => [
                    'url' => $url = Url::to(['generic/get-cellar']),
                    'dataType' => 'json',
                    'data' => new JsExpression('function(params) { return {q:params.term}; }')
                ],
                'escapeMarkup' => new JsExpression('function (markup) {return markup; }'),
                'templateResult' => new JsExpression('function(data) { return data.text; }'),
                'templateSelection' => new JsExpression('function (data) { '
                            . 'tmpText = data.text;'
                            . 'getMulitocation(data.id);'
                            . 'text = tmpText.split(" - ")[1];'
                            . '$("#configpdv-name_cellar_in").val(text);'
                            . 'return data.text; }'),
            ],
            ]);?>

        <?= $form->field($model, 'name_cellar_in')->hiddenInput()->label(false)->error(false) ?>

        <?= $form->field($model, 'multi_ubicacion')->hiddenInput()->label(false)->error(false) ?>

        <?= $form->field($model, 'id_cellar_out')->widget(Select2::classname(), [
            'initValueText' => $cellar_out,
            'options' => [
                'placeholder' => 'Seleccione Bodega...',
            ],
            'theme' => Select2::THEME_DEFAULT,
            'pluginOptions' => [
                'allowClear' => true,
                'minimumInputLength' => 1,
                'language' => [
                    'errorLoading' => new JsExpression("function () { return 'Buscando...'; }"),
                    'inputTooShort' => new JsExpression("function () { return 'Por favor ingrese 1 o más carácteres'; }"),
                    'searching' =>  new JsExpression("function () { return 'Buscando...'; }"),
                ],
                'ajax' => [
                    'url' => $url = Url::to(['generic/get-cellar']),
                    'dataType' => 'json',
                    'data' => new JsExpression('function(params) { return {q:params.term}; }')
                ],
                'escapeMarkup' => new JsExpression('function (markup) {return markup; }'),
                'templateResult' => new JsExpression('function(data) { return data.text; }'),
                'templateSelection' => new JsExpression('function (data) { '
                    . 'tmpText = data.text;'
                    . 'text = tmpText.split(" - ")[1];'
                    . '$("#configpdv-name_cellar_out").val(text); '
                    . 'return data.text; }'),
            ],
        ]);?>

        <?= $form->field($model, 'name_cellar_out')->hiddenInput()->label(false)->error(false) ?>

        <div class="form-group">
            <?= Html::submitButton(Yii::t('app', 'Save'), ['class' => 'btn btn-success']) ?>
            <?= Html::a(Yii::t('app', 'Cancel'), ['index'], ['class' => 'btn btn-default']) ?>
        </div>

        <?php ActiveForm::end(); ?>

    </div>
</div>

<script type="text/javascript">
    function getMulitocation(id){
        $.ajax({
            url: '<?php echo Url::to(['generic/get-multilocation']); ?>',
            type: "GET",
            data: {
                "id": id
            },
            success: function(result){
                $('#configpdv-multi_ubicacion').val(result.multilocation);
                return true;
            }
        })
    }
</script>