<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Configpdv */

$this->title = $model->name_pdv;
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Configpdvs'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="configpdv-view box box-solid">
    <div class="box-body with-border">
        <?= Html::a(Yii::t('app', 'Update'), ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
        <?= Html::a(Yii::t('app', 'Delete'), ['delete', 'id' => $model->id], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => Yii::t('app', 'Are you sure you want to delete this item?'),
                'method' => 'post',
            ],
        ]) ?>
        <?= Html::a(Yii::t('app', 'Cancel'), ['index', 'id' => $model->id], ['class' => 'btn btn-default']) ?>
    </div>
    <div class="box-body">
    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'name_cia',
            'code_pdv',
            'name_pdv',
            'name_group_co',
            'name_co',
            [
                'attribute' => 'name_cellar_in',
                'value' => function($model){
                    return $model['id_cellar_in'].' - '.$model['name_cellar_in'];
                }
            ],
            [
                'attribute' => 'name_cellar_out',
                'value' => function($model){
                    return $model['id_cellar_out'].' - '.$model['name_cellar_out'];
                }
            ],
            [
                'attribute' => 'multi_ubicacion',
                'value' => function($model){
                    return $model->multi_ubicacion == 1 ? 'Si' : 'No';
                }
            ],
            'created',
            'created_by'
        ],
    ]) ?>
    </div>
</div>
