<?php
use yii\helpers\ArrayHelper;
use yii\bootstrap\Html;
use \app\models\InOut;
use \app\models\InOutDetail;

#Decalramos modelo detalle pedidos para extraer labels -------------------------
$entryDetail = new InOut();

#Traemso los datos si el pedido ya existe --------------------------------------
$productosAntSIESA = [] ;   
if(!empty($pedido)){
    $productosAnt = InOutDetail::find()->where(['in_out_id'=>$pedido])
            ->asArray()->all();
    $productosAntSIESA = ArrayHelper::index($productosAnt, 'reference');
}

# Separamso los productos por ERP ----------------------------------------------
$productosERP = ArrayHelper::index($listProduct, 'referencia' , ['erp']);
$productosSIESA = isset($productosERP['siesa']) ? $productosERP['siesa'] : [] ;

# Traemos las categorias  ------------------------------------------------------
$listCategorySIESA = ArrayHelper::index($productosSIESA, 'referencia', ['categoria_id']);

# Validamos las columnas a mostrar segun la resolucion de la pantalla ----------
$shReferencia = '';
$shUnidadMedida = '';
$shCantidad = 0;
$shDescripcion = $shReferencia;
if($ancho < 600){
    $shUnidadMedida  = $shReferencia = 'display: none';
}
if($ancho >= 600 && $ancho <= 900){
    $shReferencia = 'display: none';
}

?>
    
<?php if(count($listCategorySIESA) > 0 ): ?> 
    <?php if(count($listCategorySIESA) > 0): ?>
    
    <div class="box-body">
        <h4 class="box-title">
            <strong><?= Yii::t('app', 'Productos') ?></strong>
        </h4>
        <div class="box-group" id="accordion-siesa">
        <?php foreach($listCategorySIESA as $keyCategoria => $data): ?>
            <?php $firstData = current($data)?>                      
            <div class="panel box box-primary accordion-content" style="margin-bottom: -2px;">
                <div class="box-header with-border">
                    <h4 class="box-title">
                        <a data-toggle="collapse" data-parent="#accordion" 
                           href="#collapse-siesa-<?= $keyCategoria ?>" aria-expanded="false" class="collapsed">
                            <?= $firstData['nombre_categoria'] ?>
                        </a>
                    </h4>
                </div>
                <div id="collapse-siesa-<?= $keyCategoria ?>" class="panel-collapse collapse" 
                     aria-expanded="false" style="height: 0px;">
                    <div class="box-body table-responsive">
                        <table class="table table-striped" >
                            <thead>
                                <tr>
                                    <th style="<?= $shReferencia ?>"><?= $entryDetail->getAttributeLabel('Referencia')?></th>
                                    <th style="<?= $shDescripcion ?>"><?= $entryDetail->getAttributeLabel('descripcion')?></th>
                                    <th style="<?= $shUnidadMedida ?>"><?= $entryDetail->getAttributeLabel('unidad_medida')?></th>
                                    <th style="<?= $shCantidad ?>"><?= $entryDetail->getAttributeLabel('cantidad')?></th>
                                </tr>
                                <?php 
                                foreach($data as $value) { 
                                    $cantidad = 0;
                                    $precio = 0;
                                    $precioIva = 0;
                                    $iva = 0;
                                    $subSinIva = 0;
                                    $subIva = 0;
                                    $class = '';                                        
                                    $idItem = '';
                                    if(isset($productosAntSIESA[$value['referencia']])){
                                        $itemAnt = $productosAntSIESA[$value['referencia']]; 
                                        $idItem = $itemAnt['id'];   
                                        $cantidad = $itemAnt['quantity'];                                             
                                        $class = 'class="success"';                                            
                                    }                                        
                                    // -------------------------------------                                                                                                                        
                                    $id = 'siesa-'.$value['referencia'];
                                    $html = '';
                                    $html .= '<tr id="' . $id . '_tr" '.$class.'>';                                        
                                    $html .= '<td id="' . $id . '_ref" class="reference" style="'.$shReferencia.'">'
                                        . $value['referencia'] .'</td>';
                                    $html .= '<td id="' . $id . '_des" class="description" style="'.$shDescripcion.'">'
                                        . Html::hiddenInput($id . '_description',
                                            $value['descripcion'],
                                            ['id' => $id . '_description'])
                                        . $value['descripcion'] . '</td>';
                                    $html .= '<td id="' . $id . '_ref" class="unidad_medida" style="'.$shUnidadMedida.'">'
                                        . $value['unidad_medida'] .'</td>';
                                    $html .='<td style="'.$shCantidad.'">' 
                                        . Html::textInput("cantidad[$id]", $cantidad,
                                            [                                                
                                            'id' => 'orp_amount_'.$id,
                                            'class' => 'amount form-control',
                                            "onkeyup" => "calculate(this.id, '" . $id . "')"
                                            ]) .
                                        Html::hiddenInput($id . '_inv', $value['cantidad_disponible'],
                                            array(
                                            'id' => $id . '_inv')) .
                                        Html::hiddenInput($id . '_cat', $value['categoria_id'],
                                            array(
                                            'id' => $id . '_cat')) .
                                        Html::hiddenInput($id . '_amount_request', '',
                                            array(
                                            'id' => $id . '_amount_request'))
                                        . '</td>';
                                    $html .= '</tr>'; 
                                    echo $html;
                                }                                
                                ?>
                            </thead>
                        </table>
                    </div>
                </div>
            </div>                      
        <?php endforeach; ?>    
        </div>
    </div>
    <?php endif; ?>   
<?php else: ?>
    <div class="alert alert-danger">
        No se encontraron productos 
    </div>        
<?php endif; ?>
