<?php

use app\models\InOut;
use kartik\grid\GridView;
use yii\helpers\Html;
use app\models\UserSiesa;

/* @var $this yii\web\View */
/* @var $searchModel app\models\InOutSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */
$this->title = Yii::t('app', $title);
$this->params['breadcrumbs'][] = $this->title;
$user = new UserSiesa();
?>
<div class="entry-index box box-solid">
    <?php if($title == 'Input'): ?>
    <div class="box-header with-border">
        <?php /* Html::a(Yii::t('app', 'Create Entry'), ['create-in'], ['class' => 'btn btn-success']);  */ ?>
    </div>
    <?php endif; ?>

    <div class="box-body">
    <?php
    foreach (Yii::$app->session->getAllFlashes() as $key => $message) {
        echo '<div class="alert alert-' . $key . '">' . $message . '</div>';
    }
    ?>
    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            'name_cia',
            'name_business_unit',
            'number',
            'business_name',
            'type_created',
            'description:ntext',
            [
                'attribute'=>'status',
                'value'=>function($data){
                    return strtoupper($data->status);
                },
                'contentOptions' => function($data){
                    return ['class' => 'text-green'];
                }
            ],
            [
                'attribute'=>'id_user_siesa',
                'value'=>function($data) use ($user) {
                    $value = $user::findOne(['id' => $data['id_user_siesa']]);

                    if(empty($value) == false){
                        return $value->name;
                    }else{
                        return 'Jhon Mosquera';
                    }
                }
            ],
            'date',
            'created_by',
            [
                'class' => 'yii\grid\ActionColumn',
                'template' => '{view}{delete}{update}',
                'contentOptions' => ['style' => 'width:60px; white-space: normal;'],
                'visibleButtons' => [
                    'delete' => function ($data) {
                        if ($data->status != InOut::STATUS_ALLOW){
                            return true;
                        }else{
                            return false;
                        }
                    },
                    'update' => function ($data) {
                        if ($data->status != InOut::STATUS_ALLOW && $data->type_created == InOut::TYPE_CREATED_ADMID){
                            return true;
                        }else{
                            return false;
                        }
                    }
                ]
            ]
        ],
    ]); ?>
    </div>
</div>
