<?php

use app\models\UserSiesa;
use yii\helpers\Html;
use yii\widgets\DetailView;
use app\models\InOutDetail;
use yii\data\ActiveDataProvider;
use app\models\InOut;
use kartik\grid\GridView;

/* @var $this yii\web\View */
/* @var $model app\models\InOut */

$this->title =  $model->type == InOut::TYPE_IN ? Yii::t('app', 'In'). ' #: '.$model->id : Yii::t('app', 'Out'). ' #: '.$model->id;
if($model->type == InOut::TYPE_IN):
    $this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Entries'), 'url' => ['index-in']];
else:
    $this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Output'), 'url' => ['index-out']];
endif;
$this->params['breadcrumbs'][] = $this->title;

#Traemos el detalle de los items -----------------------------------------------
$query = InOutDetail::find()->where(['in_out_id'=>$model->id])
        ->orderBy('description');
$data = new ActiveDataProvider([
            'query' => $query,                     
            'pagination' => false,
            'sort' => false,
        ]);
$user = new UserSiesa();
?>
<div class="entry-view box box-solid">
    <div class="box-header with-border">
        <?php if ($model->status != InOut::STATUS_ALLOW && $model->type_created == InOut::TYPE_CREATED_ADMID): ?>
            <?= Html::a(Yii::t('app', 'Update'),
                ['update', 'id' => $model->id],
                ['class' => 'btn btn-primary'])  ?>
            <?= Html::a(Yii::t('app', 'Delete'),
                ['delete', 'id' => $model->id], [
                    'class' => 'btn btn-danger',
                    'data' => [
                        'confirm' => Yii::t('app', 'Are you sure you want to delete this item?'),
                        'method' => 'post',
                    ],
                ]) ?>
        <?php endif;?>
        <?php
        if($model->type == InOut::TYPE_IN):
            echo Html::a(Yii::t('app', 'Cancel'), ['index-in'], ['class' => 'btn btn-default']);
        else:
            echo Html::a(Yii::t('app', 'Cancel'), ['index-out'], ['class' => 'btn btn-default']);
        endif; ?>
    </div>
    <div class="box-body">
        <?= DetailView::widget([
            'model' => $model,
            'attributes' => [
                                'name_cia',
                'name_business_unit',
                'name_co',
                'description',
                [
                    'attribute' => 'type',
                    'value' => function($data){
                        return $data->type == 'in' ? 'Entrada' : 'Salida';
                    }
                ],
                'business_name',
                'number',
                'id_cellar_out',
                'name_cellar_out',
                [
                    'attribute' => 'status',
                    'value' => function($data) use ($status){
                        if(empty($status[$data['status']]) == false){
                            return $status[$data['status']];
                        }
                    },
                ],
                [
                    'attribute'=>'id_user_siesa',
                    'value'=>function($data) use ($user) {
                        $value = $user::findOne(['id' => $data['id_user_siesa']]);

                        if(empty($value) == false){
                            return $value->name;
                        }else{
                            return 'Jhon Mosquera';
                        }
                    }
                ],
                'date',
                'description:ntext',
                'created',
                'created_by',
                'modified',
                'modified_by',
            ],
        ]) ?>
    </div>
</div>
<div class="pedidos-view box box-solid">    
    <div class="box-header with-border">
        <h4 class="box-title">                
            <strong><?= Yii::t('app', 'Productos') ?></strong>
        </h4>
    </div>
    <div class="box-body">
        <?= GridView::widget([
        'dataProvider' => $data,  
        'responsive' => true,
        'responsiveWrap' => false,
        'showPageSummary' => false,
        'resizableColumns'=>true,
        'columns' => [
            ['class' => 'kartik\grid\SerialColumn'],
            'reference',
            'description',
            'lote',
            'location',
            [
                'label' => Yii::t('app', 'Adjusted Cost'),
                'attribute' => 'adjusted_cost',
                'format'=>['decimal', 2],
            ],
            [
                'label' => Yii::t('app', 'Unid Exist'),
                'attribute' => 'unid_exist',
                'format'=>['decimal', 0],
            ],
            [
                'label' => Yii::t('app', 'Quantity Count'),
                'attribute' => 'quantity_count',
                'format'=>['decimal', 0],
            ],
            [
                'label' => Yii::t('app', 'Quantity adjusted'),
                'attribute' => 'quantity',
                'format'=>['decimal', 0],
            ]
        ],
        ]); ?>
    </div>
</div>
