<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use kartik\select2\Select2;
use yii\web\JsExpression;
use yii\helpers\Url;
use kartik\depdrop\DepDrop;


/* @var $this yii\web\View */
/* @var $model app\models\InventoryType */
/* @var $form yii\widgets\ActiveForm */

$cia = $model->isNewRecord ? '' : $model->id_cia. ' - '.$model->name_cia;
$id_model  = $model->isNewRecord ? '' : $model->id;

$group = [];
if(!$model->isNewRecord){
    $group = [$model->id_group_co => $model->id_group_co.' - '.$model->name_group_co];
}

?>

<div id="div-type-inventory" class="inventorytype-form box box-solid">
    <div class="box-body">
        <?php $form = ActiveForm::begin([
            'id' => 'inventory-type'
        ]); ?>

        <div class="col-md-12 no-padding">
            <div id="error-references" class="alert alert-danger display-none" role="alert"></div>
            <div id="success-references" class="alert alert-success display-none" role="alert"></div>
        </div>

        <?= $form->field($model, 'name')->textInput(['maxlength' => true]) ?>

        <?php echo $form->field($model, 'id_cia')->widget(Select2::classname(), [
            'data' => $cias,
            'value' => $cia,
            'options' => [
                'placeholder' => 'Seleccione...',
            ],
            'theme' => Select2::THEME_DEFAULT,
            'pluginOptions' => [
                'allowClear' => true,
                'templateSelection' => new JsExpression('function (data) { '
                    . 'tmpText = data.text;'
                    . 'text = tmpText.split(" - ")[1];'
                    . '$("#inventorytype-name_cia").val(text); '
                    . 'return data.text; }'),
            ],
        ]); ?>

        <?php echo $form->field($model, 'name_cia')->hiddenInput()->label(false)->error(false) ?>

        <?= $form->field($model, 'id_group_co')->widget(DepDrop::classname(), [
            'type'=>DepDrop::TYPE_SELECT2,
            'data'=>$group,
            'select2Options'=>[
                'initValueText' => $group,
                'theme' => Select2::THEME_DEFAULT,
                'pluginOptions'=>[
                    'allowClear'=>true,
                    'escapeMarkup' => new JsExpression('function (markup) {return markup; }'),
                    'templateResult' => new JsExpression('function(data) { return data.text; }'),
                    'templateSelection' => new JsExpression('function (data) { '
                        . 'tmpText = data.text;'
                        . 'text = tmpText.split(" - ")[1];'
                        . '$("#inventorytype-name_group_co").val(text); '
                        . 'return data.text; }'),
                ],
            ],
            'pluginOptions'=>[
                'initialize' => true,
                'initDepends'=>['inventorytype-id_cia'],
                'depends'=>['inventorytype-id_cia'],
                'placeholder' => 'Seleccione...',
                'loadingText' => 'Buscando Grupos de Centros de Operaciones...',
                'url' => Url::to(['generic/get-groups'])
            ]
        ]); ?>

        <?= $form->field($model, 'name_group_co')->hiddenInput()->label(false)->error(false) ?>

        <input type="hidden" id="id_inventory_type" value="<?php echo $id_model; ?>">

        <div class="col-md-12 no-padding">
            <div id="error-references" class="alert alert-danger display-none" role="alert"></div>
            <div id="success-references" class="alert alert-success display-none" role="alert"></div>
        </div>

        <div id="list-inventory-type" class="display-none">
            <div id="error-list-references" class="alert alert-danger display-none" role="alert"></div>
            <div id="list-info-references" class="display-none"></div>
        </div>

        <div id="list-categories" class="display-none col-md-12 no-padding">
            <div id="error-list-categories" class="alert alert-danger display-none" role="alert"></div>
            <div id="list-info-categories" class="display-none"></div>
        </div>

        <div class="form-group">
            <?php echo Html::submitButton(Yii::t('app', 'Save'), ['id' => 'btn-succes-id', 'class' => 'btn btn-success btn-save', 'disabled' => 'disabled']) ?>
            <?php echo Html::a(Yii::t('app', 'Cancel'), ['index'], ['class' => 'btn btn-default']) ?>
        </div>

        <?php ActiveForm::end(); ?>
    </div>
</div>

<?php echo $this->render(
    '_categories.php'
) ?>
