<?php
    use yii\helpers\Url;
?>
<script>
    function initReady(){
        $(".get-references").click(function () {
            getReferences($(this).data('category'));
        })
    }

    $(document).ready(initReady());

    function getReferences(category){
        if(category != '' && $("."+category+"-references").html() == '' && $("."+category+"-references-error").html() == '') {
            let id_cia = $("#inventorytype-id_cia").val();
            let url = '<?php echo Url::to(['inventory-type/get-references']); ?>';
            let id_type_inventory = $("#id_inventory_type").val();
            let int_references = $("#int-references").val();

            $.ajax({
                url: url,
                type: "GET",
                data: {"id_cia": id_cia, "category": category, "id_type_inventory": id_type_inventory, "int_references": int_references},
                beforeSend: function(){
                    showLoading();
                },
                success: function(result){
                    hideLoading();
                    if(result.status == 'ERROR'){
                        $("."+category+"-load-container-categories").hide();
                        $("."+category+"-references-error").html(result.error);
                        return false;
                    }else{
                        let int = 0;
                        $("."+category+"-load-container-categories").hide();
                        $("."+category+"-references").html(result);
                        $(".btn-save").removeAttr('disabled');
                        $(".int-references").each(function() {
                            int = int+parseInt($(this).val());
                        });
                        $("#int-references").val(int);
                    }
                },
                error: function () {
                    hideLoading();
                    $("."+category+"-load-container-categories").hide();
                    $("#list-categories").show();
                    $("#error-list-categories").show().text('Error de conexión.');
                    $(".btn-save").attr('disabled', 'disabled');
                }
            });
        }else if(category == ''){
            hideLoading();
            $("#list-info-categories").hide().html('');
            $(".btn-save").attr('disabled', 'disabled');
        }
        return false;
    }

    /**
     * Muestra el icono de cargando
     * @returns {undefined}
     */
    function showLoading(){
        $("#div-type-inventory").append('<div class="overlay"><i class="fa fa-refresh fa-spin"></i></div>');
    }

    /**
     * Esconde el icono de cargando
     * @returns {undefined}
     */
    function hideLoading(){
        $(".overlay").remove();
    }
</script>

