<?php

use kartik\grid\GridView;
?>

<div class="box-header with-border">
    <h4><?= Yii::t('app', 'Products') ?></h4>
</div>
<div class="box-body">
    <div class="inventorydetail-index">
        <div class="box-body table-responsive">
            <small>
                <?php \yii\widgets\Pjax::begin(); ?>
                <?= GridView::widget([
                    'dataProvider' => $dataProvider,
                    'filterModel' => $searchModel,
                    'responsive' => true,
                    'responsiveWrap' => false,
                    'resizableColumns' => true,
                    'floatHeader' => true,
                    'floatHeaderOptions' => ['scrollingTop' => '50px'],
                    'columns' => [
                        ['class' => 'yii\grid\SerialColumn'],
                        'reference',
                        'description',
                        'name_category',
                        'measured_unit',
                        'margin_loss' => [
                            'label' => Yii::t('app', 'Margin of loss'),
                            'value' => function ($model) {
                                return $model['margin_loss'];
                            }
                        ],
                        'selected' => [
                            'label' => Yii::t('app', 'Selected'),
                            'value' => function ($model) {
                                if($model['selected'] == 'on'){
                                    return 'Si';
                                }
                                return 'No';
                            }
                        ],
                        'Calculable' => [
                            'label' => Yii::t('app', 'Calculable'),
                            'value' => function ($model) {
                                if($model['calculable'] == 'on'){
                                    return 'Si';
                                }
                                return 'No';
                            }
                        ],
                    ],
                ]); ?>
                <?php \yii\widgets\Pjax::end(); ?>
            </small>
        </div>
    </div>
</div>