<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Inventory */
/* @var $form yii\widgets\ActiveForm */
$model->consecutive  = $model->isNewRecord ? $consecutive : $model->consecutive;
$roles = \Yii::$app->authManager->getRolesByUser(Yii::$app->user->identity->getId());
$admin = array_key_exists ('Administrador', $roles);
$admin_pdv = array_key_exists ('Administrador de PVD', $roles);
$auxiliar = array_key_exists ('Auxiliar de Inventario', $roles);
$planeador = array_key_exists ('Planeador de Inventarios', $roles);

if(empty($products_simple) == false && ($auxiliar == true || $admin == true)): ?>
    <div id="dialog-products" class="ui-widget display-none">
        <h4 class="text-center font-weight-bold"><?php echo Yii::t('app', 'Calculate'); ?></h4>

        <label class="text-center margin-t-15"><?php echo Yii::t('app', 'Please select one option'); ?></label>
        <?php echo Html::dropDownList('', [], $products_simple, ['class' => 'form-control', 'id' => 'item-simple']); ?>

        <?php echo Html::input('number', null, '', ['placeholder' => Yii::t('app', 'Units'), 'id'  => 'units-simple', 'class' => 'form-control margin-t-15']); ?>
        <?php echo Html::input('number', null, '', ['placeholder' => Yii::t('app', 'Grams'), 'id'  => 'grams-simple', 'class' => 'form-control margin-t-15']); ?>

        <div id="error-products-simple" class="alert alert-danger display-none margin-t-15" role="alert">
        </div>

        <div id="success-products-simple" class="alert alert-success display-none margin-t-15" role="alert">
        </div>
    </div>
<?php endif;

if(($auxiliar == TRUE || $admin == TRUE) && $type == 'count'): ?>
    <?php if(empty($products_composed)): ?>
        <div id="dialog-products-composed-error" class="ui-widget display-none">
            <h4 class="text-center font-weight-bold"><?php echo Yii::t('app', 'Assemble'); ?></h4>

            <div class="alert alert-danger" role="alert">
                No existen elementos para ensambles.
            </div>
        </div>
    <?php else: ?>
    <div id="dialog-products-composed" class="ui-widget display-none">
        <h4 class="text-center font-weight-bold"><?php echo Yii::t('app', 'Assemble'); ?></h4>

        <label class="text-center margin-t-15"><?php echo Yii::t('app', 'Please select one option'); ?></label>
        <?php echo Html::dropDownList('', [], $products_composed, ['class' => 'form-control', 'id' => 'item-composed']); ?>

        <?php echo Html::input('number', null, '', ['placeholder' => Yii::t('app', 'Units'), 'id'  => 'units-composed', 'class' => 'form-control margin-t-15']); ?>
        <?php echo Html::input('number', null, '', ['placeholder' => Yii::t('app', 'Grams'), 'id'  => 'grams-composed', 'class' => 'form-control margin-t-15']); ?>

        <div id="error-products-composed" class="alert alert-danger display-none margin-t-15" role="alert">
        </div>

        <div id="success-products-composed" class="display-none margin-t-15" role="alert">
        </div>
    </div>
    <?php endif; ?>
<?php endif; ?>

<div id="dialog-calculator" class="ui-widget display-none">
    <h4 class="text-center font-weight-bold"><?php echo Yii::t('app', 'Calculate'); ?></h4>

    <div class="form-group">
        <div class="col-md-12 margin-t-10">
            <select id="input-operator-error" class="form-control" name="operador">
                <option value="+">Suma</option>
                <option value="-">Resta</option>
                <option value="*">Multiplicación</option>
                <option value="/">División</option>
            </select>
        </div>

        <div class="col-md-12 margin-t-10">
            <input placeholder="Ingresa el primer número" class="form-control input-calculator-1" value="0">
        </div>

        <div class="col-md-12 margin-t-10">
            <input placeholder="Ingresa el segundo número" class="form-control input-calculator-2" type="number">
        </div>

        <div id="input-calculator-error" class="alert alert-danger display-none margin-t-15" role="alert"></div>

        <div class="col-md-12 margin-t-15">
             <label>Total</label>
            <input class="form-control total-calculator" value="0" type="number" readonly>
        </div>
    </div>
</div>

<div id="div-inventory-form" class="inventory-form box box-solid">
    <div>
        <?php echo DetailView::widget([
            'model' => $model,
            'attributes' => [
                [
                    'label' => Yii::t('app', 'Consecutive'),
                    'attribute'=>'consecutive',
                    'visible' => ($admin == TRUE || $admin_pdv == TRUE || $planeador == TRUE)
                ],
                [
                    'label' => 'Compañia',
                    'attribute'=>'id_inventory_type',
                    'filter' => $cias,
                    'value'=>function($data){
                        if(empty($data->inventoryType) == FALSE){
                            return $data->inventoryType->name_cia;
                        }
                    },
                    'visible' => ($admin == TRUE || $admin_pdv == TRUE || $planeador == TRUE)
                ],
                [
                    'label' => 'Grupo de Centro de Operaciones',
                    'attribute'=>'id_inventory_type',
                    'filter' => $groups,
                    'value'=>function($data){
                        if(empty($data->inventoryType) == FALSE){
                            return $data->inventoryType->name_group_co;
                        }
                    },
                    'visible' => ($admin == TRUE || $admin_pdv == TRUE || $planeador == TRUE)
                ],
                [
                    'label' => 'Unidad de Negocio',
                    'attribute'=>'business_unit',
                    'value'=>function($data){
                        if(empty($data->business_unit) == FALSE){
                            return $data->business_unit;
                        }
                    },
                    'visible' => ($admin == TRUE || $admin_pdv == TRUE)
                ],
                'name_pdv',
                'code_name',
                [
                    'attribute'=>'id_inventory_type',
                    'filter' => $types,
                    'value'=>function($data){
                        if(empty($data->inventoryType) == FALSE){
                            return $data->inventoryType->name;
                        }
                    },
                    'visible' => ($admin == TRUE || $admin_pdv == TRUE || $planeador == TRUE)
                ],
                'created',
                'created_by',
            ],
        ]) ?>
    </div>

    <div class="inventorydetail-form box-body">
        <?php echo $this->render(
            '_formInventory.php', [
                    'model' => $model,
                    'references' => $references,
                    'reasons' => $reasons,
                    'admin' => $admin,
                    'admin_pdv' => $admin_pdv,
                    'products_simple' => $products_simple,
                    'type' => $type,
                    'users_siesa' => $users_siesa,
                    'multilocation' => $multilocation
            ]
        ) ?>
    </div>
</div>

<?php echo $this->render(
    '_validate.php', [
        'model' => $model,
        '$type' => $type
    ]
) ?>
