<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use app\models\InventoryDetail;
use yii\helpers\Url;
use kartik\dialog\Dialog;
use kartik\dialog\DialogAsset;

// widget with default options
echo Dialog::widget([
    'id' => 'dialog_ajustar',
    'libName' => 'krajeeDialogCust',
    'overrideYiiConfirm' => true
]);

DialogAsset::register($this);
$this->registerJs('$(document).on("click", "#close-adjust", function(){
   hideLoadingAdj();
})');

$this->registerJs('$(document).on("click", "#adjust", function(){
    $("#dialog-confirm-save").dialog("close");
    showLoadingAdj();
})');

$inventory_validate = "0";
$text_a_validate = Yii::t('app', 'Validate');

$roles = \Yii::$app->authManager->getRolesByUser(Yii::$app->user->identity->getId());
$admin = array_key_exists('Administrador', $roles);
$admin_pdv = array_key_exists('Administrador de PVD', $roles);

$assemble_data_1 = '';
$assemble_data_2 = '';

$disabled = [
    'c_1' => 'readonly',
    'c_2' => 'readonly',
    'd' => 'readonly'
];

$class_counting_2 = 'counting_2';

$detail_view = 'col-sm-12';
$detail_view_count_2 = 'col-sm-12';

$detail_view = [
    'c_1' => 'col-sm-10 col-xs-10',
    'c_2' => 'col-sm-10'
]; ?>

<?php $form = ActiveForm::begin([
    'id' => 'form-inventory-type',
    'action' => Url::to(['inventory/save-adjust']),
    'method' => 'post'
]); ?>

<div id="dialog-details-counts" class="ui-widget display-none">
    <h4 class="text-center font-weight-bold"><?php echo Yii::t('app', 'Details Counts'); ?></h4>
</div>

<div id="dialog-confirm-save" class="ui-widget display-none">
    <h4 class="text-center font-weight-bold"><?php echo Yii::t('app', 'Are you sure you want to adjust?'); ?></h4>

    <?php if(!empty($users_siesa)): ?>
        <select id="user-siesa" class="form-control margin-t-15">
            <?php foreach($users_siesa as $key => $usuario): ?>
                <option value="<?php echo $key ?>"><?php echo $usuario ?></option>
            <?php endforeach; ?>
        </select>
    <?php else: ?>
        <select id="user-siesa" class="form-control margin-t-15">
            <option value="0">Jhon Mosquera</option>
        </select>
    <?php endif; ?>
</div>

<div id="dialog-multilocation" class="ui-widget display-none">
    <h4 class="text-center font-weight-bold"><?php echo Yii::t('app', 'Select quantity and location'); ?></h4>

    <div class="div-multilocation"></div>
</div>

<div class="col-md-12 margin-bottom"><h3
            class="text-center"><?php echo Yii::t('app', 'Quantities in Inventory'); ?></h3>
    <h6 class="text-center"><?php echo Yii::t('app', 'Text Inventory'); ?></h6>
</div>

<div class="col-lg-12 no-padding table-responsive">
    <small>
        <input type="hidden" value="" id="reference-code">
        <div class="tableFixHead">
            <table class="table table-bordered">
                <thead class="for">
                <tr>
                    <th scope="col"></th>
                    <th scope="col"><label><?php echo Yii::t('app', 'Adjustable'); ?></label></th>
                    <th scope="col"><label><?php echo Yii::t('app', 'Category'); ?></label></th>
                    <th scope="col"><label><?php echo Yii::t('app', 'Reference'); ?></label></th>
                    <th scope="col"><label><?php echo Yii::t('app', 'Description'); ?></label></th>
                    <th scope="col"><label><?php echo Yii::t('app', 'Unit of measurement'); ?></label></th>
                    <th scope="col"><label><?php echo Yii::t('app', 'Unit price'); ?></label></th>
                    <th scope="col"><label><?php echo Yii::t('app', 'Quantity - First count (#)'); ?></label></th>
                    <th scope="col"><label><?php echo Yii::t('app', 'Quantity - Second count (#)'); ?></label></th>
                    <th scope="col" class="motivo-inventario"><label><?php echo Yii::t('app', 'Reason'); ?></label></th>
                    <th scope="col" class="nota-inventario"><label><?php echo Yii::t('app', 'Note'); ?></label></th>
                </tr>
                </thead>
                <tbody>
                <?php $int = 0; ?>
                <?php foreach ($references as $value): ?>
                    <?php if($value['status'] == InventoryDetail::STATUS_IN_PROCESS || empty($value['status'])) : ?>
                        <?php
                        if ($value['status'] == InventoryDetail::STATUS_IN_PROCESS):
                            $adjustable = true;
                        else:
                            $adjustable = false;
                        endif; ?>
                        <?php $rango_perdida = $value['margin_loss']; ?>
                        <tr>
                            <td><?php echo $int+1; ?></td>
                            <input name="Inventory_details[<?php echo $int ?>][id_inventory_detail]" type="hidden"
                                   class="" value="<?php echo trim($value['id_inventory_detail']) ?>" />

                            <td>
                                <?php if ($adjustable == true): ?>
                                    <input data-multi="true" data-reference="<?php echo $value['id']; ?>" class="check-adjustment check-<?php echo $value['reference']; ?>" type="checkbox" name="Inventory_details[<?php echo $int ?>][adjustable]" <?php echo $multilocation->multi_ubicacion == 1 ? 'onclick="setLocation(\''.$multilocation->id_cellar_in.'\', \''.$value['reference'].'\', \''.$value['description'].'\', \''.$value['id_inventory_detail'].'\', this)"' : ''; ?>>
                                <?php endif; ?>
                            </td>

                            <?php if (isset($value['id_category']) == TRUE): ?>
                                <td>
                                    <div class="form-group"><?php echo trim($value['name_category']) ?></div>
                                </td>
                            <?php elseif ($admin == TRUE || $admin_pdv == TRUE): ?>
                                <td></td>
                            <?php endif; ?>

                            <?php if (isset($value['reference']) == TRUE): ?>
                                <td>
                                    <div class="form-group"><?php echo trim($value['reference']) ?></div>
                                </td>
                            <?php else: ?>
                                <td></td>
                            <?php endif; ?>

                            <?php if (isset($value['description']) == TRUE): ?>
                                <td>
                                    <div class="form-group"><?php echo trim($value['description']) ?></div>
                                </td>
                            <?php else: ?>
                                <td></td>
                            <?php endif; ?>

                            <?php if (isset($value['measured_unit']) == TRUE): ?>
                                <td>
                                    <div class="form-group"><?php echo trim($value['measured_unit']) ?></div>
                                </td>
                            <?php else: ?>
                                <td></td>
                            <?php endif; ?>

                            <?php if (isset($value['unit_price']) == TRUE): ?>
                                <td>
                                    <div class="form-group"><?php echo trim($value['unit_price']) ?></div>
                                </td>
                            <?php elseif ($admin == TRUE || $admin_pdv == TRUE): ?>
                                <td></td>'
                            <?php endif; ?>

                            <?php $couting_1 = isset($value['counting_1']) == TRUE ? $value['counting_1'] : 0; ?>
                            <?php $assemble_1 = isset($value['assemble_1']) == TRUE ? $value['assemble_1'] : 0; ?>
                            <td>
                                <div class="form-group">
                                    <div class="<?php echo $detail_view['c_1']; ?> padding-right-none">
                                        <input min="0" name="Inventory_details[<?php echo $int ?>][counting_1]" type="number"
                                               data-reference="<?php echo $value['description']; ?>"
                                               class="form-control counting_1" <?php echo $disabled['c_1'] ?>
                                               value="<?php echo $couting_1 ?>"/>
                                    </div>

                                    <?php if ($admin == TRUE || $admin_pdv == TRUE): ?>
                                        <div class="col-sm-2 col-xs-2 no-padding text-center">
                                            <a data-count="1" data-reference="<?php echo $value['id']; ?>" data-type="counting"
                                               class="details-cont btn" title="Ver Detalle"><i
                                                        class="glyphicon glyphicon-list-alt"></i></a>
                                        </div>
                                    <?php endif; ?>

                                    <div class="<?php echo $detail_view['c_1']; ?> padding-right-none margin-t-15 has-feedback">
                                        <input min="0" name="Inventory_details[<?php echo $int ?>][assemble_1]" type="number"
                                               class="form-control assemble_1" <?php echo $assemble_data_1; ?> readonly
                                               value="<?php echo $assemble_1 ?>">
                                        <span class="cursor-pointer display-none clearer glyphicon glyphicon-remove-circle form-control-feedback"></span>
                                    </div>

                                    <?php if ($admin == TRUE || $admin_pdv == TRUE && ($couting_1 != '' || $assemble_1 != '')): ?>
                                        <div class="col-sm-2 col-xs-2 no-padding text-center margin-t-15 margin-t-15">
                                            <a data-count="1" data-reference="<?php echo $value['id']; ?>" data-type="assemble"
                                               class="details-cont btn" title="Ver Detalle"><i
                                                        class="glyphicon glyphicon-list-alt"></i></a>
                                        </div>
                                    <?php endif; ?>
                                </div>
                            </td>

                            <?php $couting_2 = isset($value['counting_2']) == TRUE ? $value['counting_2'] : ''; ?>
                            <?php $assemble_2 = isset($value['assemble_2']) == TRUE ? $value['assemble_2'] : ''; ?>

                            <td>
                                <div class="form-group">
                                    <div class="<?php echo $detail_view['c_2']; ?> padding-right-none">
                                        <input class="form-control <?php echo $class_counting_2; ?>" min="0"
                                               name="Inventory_details[<?php echo $int ?>][counting_2]"
                                               data-reference="<?php echo $value['description']; ?>" type="number"
                                               value="<?php echo $couting_2 ?>" <?php echo $disabled['c_2'] ?>/>
                                    </div>

                                    <?php if (($admin == TRUE || $admin_pdv == TRUE) && $couting_2 != ''): ?>
                                        <div class="col-sm-2 col-xs-2 no-padding text-center">
                                            <a data-count="2" data-reference="<?php echo $value['id']; ?>" data-type="counting"
                                               class="details-cont btn" title="Ver Detalle"><i
                                                        class="glyphicon glyphicon-list-alt"></i></a>
                                        </div>
                                    <?php endif; ?>

                                    <div class="<?php echo $detail_view['c_2']; ?> padding-right-none margin-t-15 has-feedback">
                                        <input class="form-control  <?php echo $class_counting_2; ?>" min="0"
                                               name="Inventory_details[<?php echo $int ?>][assemble_2]"
                                               type="number" <?php echo $assemble_data_2; ?> value="<?php echo $assemble_2 ?>"
                                               readonly/>
                                        <span class="cursor-pointer display-none clearer glyphicon glyphicon-remove-circle form-control-feedback"></span>
                                    </div>

                                    <?php if (($admin == TRUE || $admin_pdv == TRUE) && ($couting_2 != '' || $assemble_2 != '')): ?>
                                        <div class="col-sm-2 col-xs-2 no-padding text-center margin-t-15 margin-t-15">
                                            <a data-count="2" data-reference="<?php echo $value['id']; ?>" data-type="assemble"
                                               class="details-cont btn" title="Ver Detalle"><i
                                                        class="glyphicon glyphicon-list-alt"></i></a>
                                        </div>
                                    <?php endif; ?>
                                </div>
                            </td>

                            <?php $reason = isset($value['reason']) == TRUE ? $value['reason'] : ''; ?>
                            <td class="motivo-inventario">
                                <div class="form-group">
                                    <select name="Inventory_details[<?php echo $int ?>][reason]" class="form-control"
                                            disabled <?php echo $disabled['d'] ?>>
                                        <option value=""></option>
                                        <?php foreach ($reasons as $key => $reasonValue): ?>
                                            <option <?php echo $key == $reason ? 'selected' : ''; ?>
                                                    value="<?php echo $key ?>"><?php echo $reasonValue ?></option>
                                        <?php endforeach; ?>
                                    </select>
                                </div>
                            </td>
                            <?php $nota = isset($value['notes']) == TRUE ? $value['notes'] : ''; ?>
                            <td class="nota-inventario" <?php echo $disabled['c_2'] ?>>
                                <div class="form-group"><textarea name="Inventory_details[<?php echo $int ?>][notes]"
                                                                  class="form-control" <?php echo $disabled['d'] ?>><?php echo $nota ?></textarea>
                                </div>
                            </td>
                        </tr>
                        <?php $int++; ?>
                    <?php endif; ?>
                <?php endforeach; ?>
                </tbody>
            </table>
        </div>
    </small>
</div>

<input type="hidden" name="user_siesa_input" id="user_siesa_input" value="0"/>

<input type="hidden" name="Inventory_id" id="id_inventory" value="<?php echo $model->id; ?>"/>

<input type="hidden" name="type" value="<?php echo $type; ?>"/>

<div class="col-md-12 no-padding">
    <div id="error-validate" class="alert alert-danger display-none" role="alert"></div>
    <div id="success-validate" class="alert alert-success display-none" role="alert"></div>
</div>

<div class="div-ppal-adj">

</div>

<div class="form-group">
    <?php echo Html::submitButton(Yii::t('app', 'Adjust'), ['class' => 'btn btn-success btn-save', 'id' => 'submit-adjust']) ?>
    <?php echo Html::a(Yii::t('app', 'Cancel'), ['view', 'id' => $model->id], ['class' => 'btn btn-default']) ?>
</div>

<?php ActiveForm::end(); ?>

<script>
    /**
     * Muestra el icono de cargando
     * @returns {undefined}
     */
    function showLoadingAdj() {
        $("#div-inventory-form").append('<div class="overlay"><i class="fa fa-refresh fa-spin"></i></div>');
    }

    /**
     * Esconde el icono de cargando
     * @returns {undefined}
     */
    function hideLoadingAdj() {
        $(".overlay").remove();
    }
</script>
