<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use app\models\InventoryDetail;
use app\models\Inventory;

$inventory_validate = "0";
$text_a_validate = Yii::t('app', 'Validate');

$display = [
    'c_1' => 'display-none',
    'c_2' => 'display-none'
];

$detail_view = [
    'c_1' => 'col-sm-10',
    'c_2' => 'col-sm-12',
    'c_1_ass' => 'col-sm-12',
    'c_2_ass' => 'col-sm-12'
];

$class_counting_2 = 'counting_2';
$assemble_data_1 = '';
$assemble_data_2 = '';
$display_calculator = '';
$readonly = '';
$readonly_c = '';

if (($admin == TRUE || $admin_pdv == TRUE) && $type == 'validate') {
    $detail_view['c_1'] = 'col-sm-12 col-xs-12';
    $detail_view['c_1_ass'] = 'col-sm-10 col-xs-10';
    $readonly = 'readonly';
}

switch ($model->code_status):
    case Inventory::STATUS_PENDIENTE_2:
        if (($auxiliar == TRUE || $admin == TRUE) && $type == 'count') {
            $display['c_2'] = '';
            $detail_view['c_1'] = 'col-sm-12';
            $detail_view['c_2'] = 'col-sm-10';
            $detail_view['c_1_ass'] = 'col-sm-12';
            $detail_view['c_2_ass'] = 'col-sm-12';
            $readonly_c = 'readonly';
        }
        if (($admin == TRUE || $admin_pdv == TRUE) && $type == 'validate') {
            $display['c_2'] = '';
            $detail_view['c_1'] = 'col-sm-12';
            $detail_view['c_2'] = 'col-sm-12';
            $detail_view['c_1_ass'] = 'col-sm-10';
            $detail_view['c_2_ass'] = 'col-sm-10';
        }
        break;
endswitch; ?>

<?php

if($type == 'validate'):
    $form = ActiveForm::begin(
        ['id' => 'form-inventory-validate']
    );
else:
    $form = ActiveForm::begin(
        ['id' => 'form-inventory-type']
    );
endif; ?>

<div id="div-inventory-count" class="box box-solid">

    <div id="dialog-details-counts" class="ui-widget display-none">
        <h4 class="text-center font-weight-bold"><?php echo Yii::t('app', 'Details Counts'); ?></h4>
    </div>

    <div id="dialog-details-assemble" class="ui-widget display-none">
        <h4 class="text-center font-weight-bold"><?php echo Yii::t('app', 'Details Assemble'); ?></h4>
    </div>

    <div class="col-md-12 margin-bottom">
        <h3 class="text-center"><?php echo Yii::t('app', 'Quantities in Inventory'); ?></h3>
        <h6 class="text-center"><?php echo Yii::t('app', 'Text Inventory'); ?></h6>
    </div>

<?php if (($auxiliar == TRUE || $admin == TRUE) && $type == 'count'): ?>
    <div class="text-right margin-bt-25">
        <?php echo Html::a('<span class="glyphicon glyphicon-list-alt"></span> ' . Yii::t('app', 'Assemble'), null, ['class' => 'cursor-pointer calculable-composed']); ?>
    </div>
<?php endif; ?>

    <div class="col-lg-12 no-padding form-group text-right">
        <?php if (($auxiliar == TRUE || $admin == TRUE) && $type == 'count'): ?>
            <?php echo Html::submitInput(Yii::t('app', 'Save'), ['class' => 'btn btn-success btn-save', 'id' => 'submit-inventory']) ?>
        <?php elseif (($admin == TRUE || $admin_pdv == TRUE) && $type == 'validate'): ?>
            <?php echo Html::submitButton($text_a_validate, ['class' => 'btn btn-success btn-save', 'id' => 'submit-inventory-validate']) ?>
        <?php endif; ?>
        <?php echo Html::a(Yii::t('app', 'Cancel'), ['view', 'id' => $model->id], ['class' => 'btn btn-default']) ?>
    </div>

    <div class="">
        <small>
            <div class="col-lg-12 no-padding table-responsive tableFixHead">
                <table class="table table-bordered">
                    <thead class="for">
                    <tr>
                        <th scope="col"></th>
                        <th width="20%" scope="col"><label><?php echo Yii::t('app', 'Reference'); ?></label></th>
                        <th width="20%" scope="col"><label><?php echo Yii::t('app', 'Description'); ?></label></th>
                        <th width="20%" scope="col"><label><?php echo Yii::t('app', 'Unit of measurement'); ?></label></th>
                        <th width="20%" scope="col">
                            <label><?php echo Yii::t('app', 'Quantity - First count (#)'); ?></label></th>
                        <th class="<?php echo $display['c_2']; ?>" width="20%" scope="col">
                            <label><?php echo Yii::t('app', 'Quantity - Second count (#)'); ?></label></th>
                    </tr>
                    </thead>
                    <tbody>
                    <?php $int = 0; ?>

                    <?php foreach ($references as $value):
                    ?>
                        <?php if($value['status'] == InventoryDetail::STATUS_IN_PROCESS || empty($value['status'])) : ?>
                            <?php if (empty($value['calculable']) == false && $value['calculable'] == 'on'):
                                $calculable = 'calculable';
                            else:
                                $calculable = '';
                            endif; ?>
                            <?php $rango_perdida = $value['margin_loss']; ?>
                            <tr>
                                <td><?php echo $int+1; ?></td>
                                <input name="Inventory_details[<?php echo $int ?>][id_reference]" type="hidden"
                                       value="<?php echo trim($value['id']) ?>"/>

                                <?php if (isset($value['id_inventory_detail']) == TRUE): ?>
                                    <input name="Inventory_details[<?php echo $int ?>][id_inventory_detail]" type="hidden"
                                           value="<?php echo trim($value['id_inventory_detail']) ?>"/>
                                <?php endif; ?>

                                <?php if (isset($value['reference']) == TRUE): ?>
                                    <td>
                                        <div class="form-group"><?php echo trim($value['reference']) ?></div>
                                    </td>
                                <?php else: ?>
                                    <td></td>
                                <?php endif; ?>

                                <?php if (isset($value['description']) == TRUE): ?>
                                    <td>
                                        <div class="form-group"><?php echo trim($value['description']) ?></div>
                                    </td>
                                <?php else: ?>
                                    <td></td>
                                <?php endif; ?>

                                <?php if (isset($value['measured_unit']) == TRUE): ?>
                                    <td>
                                        <div class="form-group"><?php echo trim($value['measured_unit']) ?></div>
                                    </td>
                                <?php else: ?>
                                    <td></td>
                                <?php endif; ?>

                                <?php
                                switch ($model->code_status):
                                    case Inventory::STATUS_PENDIENTE_1;
                                        $assemble_data_1 = 'data-assemble = ' . $value['reference'];
                                        $assemble_data_2 = '';
                                        break;
                                    case Inventory::STATUS_PENDIENTE_2;
                                        if (($value['status'] == InventoryDetail::STATUS_IN_PROCESS || empty($value['status']) == true) && $type == 'count'):
                                            $assemble_data_1 = '';
                                            $assemble_data_2 = 'data-assemble = ' . $value['reference'];
                                            $class_counting_2 = 'counting_2';
                                            $display_calculator = 'display-none';
                                        elseif ($type == 'count'):
                                            $assemble_data_1 = '';
                                            $assemble_data_2 = '';
                                            $class_counting_2 = '';
                                        endif;
                                        break;
                                endswitch; ?>

                                <?php $couting_1 = isset($value['counting_1']) == TRUE ? $value['counting_1'] : 0; ?>
                                <?php $assemble_1 = isset($value['assemble_1']) == TRUE ? $value['assemble_1'] : 0; ?>
                                <td>
                                    <div class="form-group position-initial">
                                        <?php if ($type == 'count'): ?>
                                        <div class="col-sm-2 <?php echo $display_calculator; ?> col-xs-2 no-padding text-center">
                                            <a data-count="1" data-reference="<?php echo $value['id']; ?>" class="calculator btn" title="Calculadora">
                                                <i class="glyphicon glyphicon-scale"></i></a>
                                        </div>
                                        <?php endif; ?>

                                        <div class="<?php echo $detail_view['c_1']; ?> col-xs-2 padding-right-none">
                                            <input min="0" name="Inventory_details[<?php echo $int ?>][counting_1]"
                                                   type="number" step="any"
                                                   data-reference="<?php echo $value['description']; ?>"
                                                   class="form-control input-couting counting_1 value_1_<?php echo $value['id']; ?>" <?php echo $readonly; ?> <?php echo $readonly_c; ?>
                                                   value="<?php echo $couting_1 ?>"/>
                                        </div>

                                        <?php if (($admin == TRUE || $admin_pdv == TRUE) && $type == 'validate'): ?>
                                        <div class="margin-t-15 col-sm-2 col-xs-2 no-padding text-center">
                                            <a data-count="1" data-reference="<?php echo $value['id']; ?>"
                                               data-type="counting" class="details-cont btn" title="Ver Detalle"><i
                                                        class="glyphicon glyphicon-list-alt"></i></a>
                                        </div>
                                        <?php endif; ?>

                                        <div class="<?php echo $detail_view['c_1_ass']; ?> padding-right-none margin-t-15 has-feedback">
                                            <input min="0" name="Inventory_details[<?php echo $int ?>][assemble_1]"
                                                   type="number" step="any"
                                                   class="form-control assemble_1" <?php echo $assemble_data_1; ?> readonly
                                                   value="<?php echo $assemble_1 ?>">
                                            <span class="cursor-pointer display-none clearer glyphicon glyphicon-remove-circle form-control-feedback"></span>
                                        </div>
                                    </div>
                                </td>

                                <?php $couting_2 = isset($value['counting_2']) == TRUE ? $value['counting_2'] : ''; ?>
                                <?php $assemble_2 = isset($value['assemble_2']) == TRUE ? $value['assemble_2'] : ''; ?>

                                <td class="<?php echo $display['c_2']; ?>">
                                    <div class="form-group position-initial">
                                        <?php if ($type == 'count'): ?>
                                        <div class="col-sm-2 col-xs-2 no-padding text-center">
                                            <a data-count="2" data-reference="<?php echo $value['id']; ?>" class="calculator btn" title="Calculadora">
                                                <i class="glyphicon glyphicon-scale"></i></a>
                                        </div>
                                        <?php endif; ?>

                                        <div class="<?php echo $detail_view['c_2']; ?> padding-right-none">
                                            <input class="input-couting form-control <?php echo $class_counting_2 . ' ' . $calculable; ?>  value_2_<?php echo $value['id']; ?>"
                                                   min="0" name="Inventory_details[<?php echo $int ?>][counting_2]"
                                                   data-reference="<?php echo $value['description']; ?>" type="number" <?php echo $readonly; ?>
                                                   step="any" value="<?php echo $couting_2 ?>"/>
                                        </div>

                                        <?php if (($admin == TRUE || $admin_pdv == TRUE) && $type == 'validate'): ?>
                                        <div class="col-sm-2 col-xs-2 no-padding text-center margin-t-15">
                                            <a data-count="2" data-reference="<?php echo $value['id']; ?>"
                                               data-type="counting" class="details-cont btn" title="Ver Detalle"><i
                                                        class="glyphicon glyphicon-list-alt"></i></a>
                                        </div>
                                        <?php endif; ?>

                                        <div class="<?php echo $detail_view['c_2_ass']; ?> padding-right-none margin-t-15 has-feedback">
                                            <input class="form-control  <?php echo $class_counting_2; ?>" min="0"
                                                   name="Inventory_details[<?php echo $int ?>][assemble_2]"
                                                   type="number" step="any" <?php echo $assemble_data_2; ?>
                                                   value="<?php echo $assemble_2 ?>" readonly/>
                                            <span class="cursor-pointer display-none clearer glyphicon glyphicon-remove-circle form-control-feedback"></span>
                                        </div>
                                    </div>
                                </td>
                            </tr>
                            <?php $int++; ?>
                        <?php endif; ?>
                    <?php endforeach; ?>
                    </tbody>
                </table>
            </div>
        </small>
    </div>

    <input class="btn btn-success btn-save" type="hidden" name="type_request" id="type_request" value=">"/>

    <input class="btn btn-success btn-save" type="hidden" id="id_inventory" value="<?php echo $model->id; ?>"/>

    <input type="hidden" name="inventory_validate" id="inventory_validate" value="<?php echo $inventory_validate ?>">

    <input type="hidden" name="type" value="<?php echo $type; ?>"/>

    <div class="col-md-12 no-padding">
        <div id="error-validate" class="alert alert-danger display-none" role="alert"></div>
        <div id="success-validate" class="alert alert-success display-none" role="alert"></div>
    </div>

<?php ActiveForm::end(); ?>

</div>
