<?php

use app\models\InventoryType;
use app\models\Param;
use yii\helpers\ArrayHelper;

/* @var $this yii\web\View */
/* @var $model app\models\Inventory */

$this->title = Yii::t('app', 'Update Inventories: ').$model->consecutive;
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Update Inventories'), 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->id, 'url' => ['view', 'id' => $model->id]];
$this->params['breadcrumbs'][] = Yii::t('app', 'Update');
?>
<div class="inventory-update">
    <?php echo $this->render('_form', [
        'model' => $model,
        'references' => $references,
        'inventoryDetail' => $inventoryDetail,
        'cias' => ArrayHelper::map(InventoryType::find()->select(['id_cia', 'name_cia'])->groupBy('name_cia')->asArray()->all(), 'id_cia', 'name_cia'),
        'groups' => ArrayHelper::map(InventoryType::find()->select( ['id_group_co', 'name_group_co'])->groupBy('name_group_co')->asArray()->all(), 'id_group_co', 'name_group_co'),
        'pdv_list' => $pdv_list,
        'types' => Yii::$app->runAction('generic/get-inventory-type-drop', []),
        'reasons' => json_decode(Param::findOne(['key' => 'reasons_inventory'])->value, true),
        'products_simple' => $products_simple,
        'products_composed' => $products_composed,
        'type' => $type,
        'users_siesa' => $users_siesa,
        'multilocation' => $multilocation,
    ]) ?>
</div>
