<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $searchModel app\models\ParamSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = Yii::t('app', 'Params');
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="param-index box box-solid">
    <div class="box-header with-border">
        <p>
            <?= Html::a(Yii::t('app', 'Create Param'), ['create'], ['class' => 'btn btn-success']) ?>
        </p>
    </div>
    <div class="box-body">
        <?= GridView::widget([
            'dataProvider' => $dataProvider,
            'filterModel' => $searchModel,
            'columns' => [
                'key',
                'value:ntext',
                'description:ntext',
                'deleted',
                [
                    'class' => 'yii\grid\ActionColumn',
                    'visibleButtons' => [
                        'delete' => function ($data) {
                            if ($data->deleted === \app\models\Param::DELETED_SI){
                                return true;
                            }else{
                                return false;
                            }            
                        },
                    ]
                ],
            ],
        ]); ?>
    </div>
</div>
