<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use kartik\sortinput\SortableInput;
use yii\helpers\Url;
use app\assets\PuglinsAsset;
use miloschuman\highcharts\Highcharts;
use kartik\select2\Select2;
use yii\web\JsExpression;
use kartik\depdrop\DepDrop;

PuglinsAsset::register($this);

/* @var $this yii\web\View */
/* @var $model app\models\Reports */
/* @var $form yii\widgets\ActiveForm */

$btnRefress = Html::a("<i class='glyphicon glyphicon-refresh'></i> "
    .Yii::t('app', 'Refrescar'),
    ($model->isNewRecord ? ['create'] : ['update', 'id'=>$model->id]),
    ['class' => 'btn btn-default']);
?>

<div id="div-reports" class="reports-form box box-solid <?= (!$model->isNewRecord)? 'collapsed-box' : '' ?>">
    <?php if(!$model->isNewRecord): ?>
        <div class="box-header with-border">
            <h3 class="box-title"><strong><?= Yii::t('app', 'Parametros') ?></strong></h3>
            <div class="box-tools pull-right">
                <button type="button" class="btn btn-box-tool" data-widget="collapse"><i class="fa fa-plus"></i>
                </button>
            </div>
        </div>
    <?php endif; ?>
    <div class="box-body">
        <?php $form = ActiveForm::begin(
            [
                'id' => 'report-form'
            ]
        ); ?>

        <?= $form->field($model, 'name')->textInput(['maxlength' => true]) ?>

        <h5><strong><?= Yii::t('app', 'Parámetros adicionales') ?></strong></h5>
        <?= SortableInput::widget([
            'model' => $model,
            'name'=>'addParameters',
            'value'=>$valueListParametersAdd,
            'items' => $listParametersAdd,
            'hideInput' => true,
            'sortableOptions' => [
                'itemOptions'=>['style' => 'min-height: 10%; font-size: 85%;'],
                'connected'=>true,
                'type'=>'grid'
            ],
            'options' => ['class'=>'form-control', 'readonly'=>true]
        ]);
        ?>

        <h5><strong><?= Yii::t('app', 'Parámetros del Reporte') ?></strong></h5>
        <?= SortableInput::widget([
            'model' => $model,
            'name' => 'defaultParameters',
            'value' => $valueListDefaultParameters,
            'items' => $listDefaultParameters,
            'hideInput' => true,
            'sortableOptions' => [
                'itemOptions'=>['style' => 'min-height: 10%; font-size: 85%;'],
                'connected'=>true,
                'type'=>'grid'
            ],
            'options' => ['class'=>'form-control', 'readonly'=>true]
        ]); ?>

        <hr>
        <div class="form-group">
            <div>
                <?= Html::submitButton($model->isNewRecord ? Yii::t('app', 'Save') : Yii::t('app', 'Update'), ['class' => 'btn btn-success', 'name'=>'create']) ?>

                <?= Html::a(Yii::t('app', 'Visualizar'), null, ['class' => 'btn btn-danger', 'id'=>'preview']) ?>

                <?= Html::a(Yii::t('app', 'Cancel'), ['index'], ['class' => 'btn btn-default']) ?>
            </div>
        </div>

        <?php ActiveForm::end(); ?>

    </div>
</div>

<div id="inventories">
    <?php if(empty($dataProvider) == FALSE): ?>
        <?php echo $this->render(
            '_inventories', [
            'model' => $model,
            'dataProvider' => $dataProvider,
            'preview' => $preview,
            'columns' => $columns,
            'btnRefress' => null,
            'searchModel' => $searchModel,
            'listDefaultParameters' => $listDefaultParameters,
            'listParametersAdd' => $listParametersAdd,
            'valueListParametersAdd' => $valueListParametersAdd,
            'valueListDefaultParameters' => $valueListDefaultParameters,
        ]); ?>
    <?php endif; ?>
</div>

<div class="col-md-12 no-padding">
    <div id="error" class="alert alert-danger display-none" role="alert"></div>
    <div id="success" class="alert alert-success display-none" role="alert"></div>
</div>

<?php echo $this->render(
    '_complement.php'
) ?>