<?php

use yii\helpers\Html;
use miloschuman\highcharts\Highcharts;
use kartik\select2\Select2;

$dropdownGrafica = [];

if(count($listDefaultParameters)>0){
    foreach ($listDefaultParameters as $key => $value) {
        $dropdownGrafica[$key] = $value['content'];
    }
}
#-------------------------------------------------------------------------------
$selectType = !empty($model->type)? $model->type : '';
$selectEjeX = !empty($model->ejex)? explode(',', $model->ejex) : null;
$selectEjeY = !empty($model->ejey)? explode(',', $model->ejey) : null;
$this->registerJsFile('@web/js/grouped-categories.js',
    ['position' => \yii\web\View::POS_END,
        'depends'=> \miloschuman\highcharts\HighchartsAsset::className()]);

?>

<div class="reports-gridw box box-solid" id="box-graficas">
    <?php if(!$model->isNewRecord): ?>
        <div class="box-header with-border">
            <h3 class="box-title"><strong><?= Yii::t('app', 'grafica') ?></strong></h3>
            <div class="box-tools pull-right">
                <button type="button" class="btn btn-box-tool" data-widget="collapse">
                    <i class="fa fa-minus"></i>
                </button>
            </div>
        </div>
    <?php endif; ?>
    <div class="box-body">
        <div class="row">
            <div class="col-lg-offset-1 col-md-3">
                <?= Html::label( Yii::t('app', 'Type'), 'type',
                    ['class'=>'control-label', 'style'=>'padding-top: 7px;']) ?>
                <?= Html::dropDownList('type', $selectType,
                    ['area'=>'Área', 'line'=>'Línea', 'column'=>'Barras'],
                    ['class'=>'form-control', 'id'=>'type']) ?>
                <?= Html::hiddenInput('id', $model->id, ['id'=>'id_report']) ?>
            </div>
            <div class="col-md-3">
                <?= Html::label('Eje X', 'ejex',
                    ['class'=>'control-label', 'style'=>'padding-top: 7px;']) ?>
                <?= Select2::widget([
                    'name' => 'ejex',
                    'id' => 'ejex',
                    'data' => $dropdownGrafica,
                    'value' => $selectEjeX,
                    'theme' => Select2::THEME_DEFAULT,
                    'maintainOrder' => true,
                    'options' => [
                        'placeholder' => 'Seleccione ...',
                        'multiple' => true
                    ],
                    'pluginOptions' => [
                        'allowClear' => true,
                        'tags' => true,
                        'maximumSelectionLength' => '3'
                    ],
                ])?>
            </div>
            <div class="col-md-3">
                <?= Html::label('Eje Y', 'ejey',
                    ['class'=>'control-label', 'style'=>'padding-top: 7px;']) ?>
                <?= Select2::widget([
                    'name' => 'ejey',
                    'id' => 'ejey',
                    'data' => $dropdownGrafica,
                    'value' => $selectEjeY,
                    'theme' => Select2::THEME_DEFAULT,
                    'maintainOrder' => false,
                    'options' => [
                        'placeholder' => 'Seleccione ...',
                        'multiple' => true
                    ],
                    'pluginOptions' => [
                        'allowClear' => true
                    ],
                ])?>
            </div>
            <div class="col-md-2" style="padding-top: 20px">
                <?= Html::button('<i class="fa fa-area-chart"></i> '
                    .Yii::t('app', 'Graficar'), [
                    'class' => 'btn btn-danger',
                    'name'=>'graficar', 'id'=>'btn-graficar']) ?>
            </div>
        </div>
        <hr>
        <div class="row">
            <div id="graph-widget" style="height:auto;" class="col-md-12">
                <?= Highcharts::widget([
                    'scripts' => [
                        'highcharts-more',
                        'modules/exporting',
                        //'themes/grid'
                    ],
                    'id' => 'chart-graph',
                    'options' => [
                        'chart' => [
                            'renderTo' => 'chart-graph',
                            'height' => '800',
                        ],
                        'lang' => [
                            'downloadJPEG' => 'Descargar en JPG',
                            'downloadPDF' => 'Descargar en PDF',
                            'downloadPNG' => 'Descargar en PNG',
                            'downloadSVG' => 'Descargar en SVG',
                            'printChart' => 'Imprimir',
                            'resetZoom' => 'Reestablecer',
                        ],
                        'title' => ['text' => 'Grafica'],
                        'xAxis' => [
                            'categories' => []
                        ],
                        'yAxis' => [
                            'title' => ['text' => 'Eje Y']
                        ],
                        'series' => [
                            ['name' => 'Grafica 1 ', 'data' => []],
                            ['name' => 'Grafica 2', 'data' => []]
                        ]
                    ]
                ]);
                ?>
            </div>
        </div>
    </div>
</div>


<?php echo $this->render(
    '_complement_graph.php'
) ?>