<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use app\models\ReportesDinamicos;

/* @var $this yii\web\View */
/* @var $model app\models\Reportes */

$this->title = $model->name;
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Reportes'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="reportes-view box box-solid">
    <div class="box-header with-border">
        <p>
            <?= Html::a(Yii::t('app', 'Update'), ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
            <?= Html::a(Yii::t('app', 'Delete'), ['delete', 'id' => $model->id], [
                'class' => 'btn btn-danger',
                'data' => [
                    'confirm' => Yii::t('app', 'Are you sure you want to delete this item?'),
                    'method' => 'post',
                ],
            ]) ?>
            <?= Html::a(Yii::t('app', 'Cancel'), ['index'], ['class' => 'btn btn-default']) ?>
        </p>
    </div>
    <div class="box-body">

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'name',
            [
                'attribute'=>'addParameters',
                'value' => function($data){
                    $reportsDynamic = new \app\models\ReportsDynamic();
                    $temp = $reportsDynamic->getTempList($data->addParameters);
                    $result = array_column($temp, 'content');                    
                    return implode(', ', $result);
                }
            ],
            [
                'attribute'=>'defaultParameters',
                'value' => function($data){
                    $reportsDynamic = new \app\models\ReportsDynamic();
                    $temp = $reportsDynamic->getTempList($data->defaultParameters);
                    $result = array_column($temp, 'content');                    
                    return implode(', ', $result);
                }
            ],
            'created',
            'created_by',
            'modified',
            'modified_by',
        ],
    ]) ?>

    </div>
</div>
