<?php

use yii\helpers\Html;
use kartik\grid\GridView;
use app\models\Requisition;

/* @var $this yii\web\View */
/* @var $searchModel app\models\RequisitionSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = Yii::t('app', 'Requisitions');
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="requisition-index box box-solid">
    <div class="box-header with-border">
        <p>
            <?= Html::a(Yii::t('app', 'Create Requisition'), ['create'], ['class' => 'btn btn-success']) ?>
        </p>
    </div>
    <div class="box-body">
    <?php
        foreach (Yii::$app->session->getAllFlashes() as $key => $message) {
            echo '<div class="alert alert-' . $key . '">' . $message . '</div>';
        }
    ?>
    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            'nit',
            'business_name',
            'num_req',
            'description:ntext',
            [
                'attribute'=>'status',
                'value'=>function($data){
                    return strtoupper($data->status);
                },
                'contentOptions' => function($data){  
                    if ($data->status != Requisition::STATUS_ALLOW){
                        return ['class' => 'text-red'];
                    }else{
                        return ['class' => 'text-green'];
                    }                        
                }
            ], 
            'date',
            [
                'class' => 'yii\grid\ActionColumn',
                'contentOptions' => ['style' => 'width:60px; white-space: normal;'],
                'visibleButtons' => [
                    'delete' => function ($data) {
                        if ($data->status != Requisition::STATUS_ALLOW){
                            return true;
                        }else{
                            return false;
                        }
                    },
                    'update' => function ($data) {
                        if ($data->status != Requisition::STATUS_ALLOW){
                            return true;
                        }else{
                            return false;
                        }
                    }
                ]
            ],
        ],
    ]); ?>
    </div>
</div>
