<?php

use yii\helpers\Html;
use kartik\grid\GridView;

/* @var $this yii\web\View */
/* @var $searchModel app\models\UserSiesa */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = Yii::t('app', 'Users SIESA');
$this->params['breadcrumbs'][] = $this->title;

?>
<div class="user-siesa-create-index box box-solid">
    <div class="box-body">

        <p>
        <?= Html::a(Yii::t('app', 'Create User SIESA'), ['create'], ['class' => 'btn btn-success']) ?>
    </p>

    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'responsive'=>true,
        'columns' => [
            'name',
            'username',
            'email',
            [
                'attribute' => 'status',
                'value' => function($model) use ($states){
                    return $states[$model['status']];
                }
            ],
            'created',
            'created_by',
            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>
    </div>
</div>
