<?php

use kartik\select2\Select2;
use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model mdm\admin\models\User */
/* @var $form yii\widgets\ActiveForm */

$admin = Yii::$app->runAction('generic/get-rol', ['rol' => 'Administrador']);
$status = $model->isNewRecord ? '' : $model->status;
?>

<div class="box box-solid">

    <div class="user-form box-body">
        <?php $form = ActiveForm::begin(); ?>

        <?= $form->field($model, 'username')->textInput() ?>
        <?= $form->field($model, 'email')->textInput() ?>
        <?= $form->field($model, 'password')->passwordInput(['maxlength' => true, 'value'=>'']) ?>
        <?= $form->field($model, 'password_repeat')->passwordInput(['maxlength' => true, 'value'=>'']) ?>

        <?php if($admin == true): ?>
            <?php echo $form->field($model, 'status')->widget(Select2::classname(), [
                'data' => $states,
                'value' => $status,
                'options' => [
                    'placeholder' => 'Seleccione...',
                ]
            ]); ?>
        <?php endif; ?>

        <div class="form-group">
            <?= Html::submitButton($model->isNewRecord ? Yii::t('app', 'Create') : Yii::t('app', 'Update'), ['class' => $model->isNewRecord ? 'btn btn-success' : 'btn btn-primary']) ?>
        </div>

        <?php ActiveForm::end(); ?>
    </div>
</div>
