<?php

use yii\helpers\Html;
use kartik\grid\GridView;

/* @var $this yii\web\View */
/* @var $searchModel app\models\UsrpdvSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = Yii::t('app', 'Usrpdvs');
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="usrpdv-index box box-solid">
    <div class="box-body">
        <p>
            <?= Html::a(Yii::t('app', 'Create Usrpdv'), ['create'], ['class' => 'btn btn-success']) ?>
        </p>
        <div class="box-body">
        <?= GridView::widget([
            'dataProvider' => $dataProvider,
            'filterModel' => $searchModel,
            'columns' => [
                'name_cia',
                [
                    'attribute'=>'name_pdv',
                    'value'=> function($model){
                        return str_replace(',', ', ', $model->name_pdv);
                    },
                    'contentOptions' => ['style' => 'width:25%;'],
                ],
                [
                    'attribute'=>'name_group_co',
                    'value'=> function($model){
                        return str_replace(',', ', ', $model->name_group_co);
                    },
                    'contentOptions' => ['style' => 'width:25%;'],
                ],
                [
                    'attribute'=>'name_co',
                    'value'=> function($model){
                        return str_replace(',', ', ', $model->name_co);
                    },
                    'contentOptions' => ['style' => 'width:25%;'],
                ],
                [
                    'attribute'=>'id_user',
                    'filter'=>$users,
                    'value'=>function($data){
                        return $data->user->username;
                    },
                ],
                ['class' => 'yii\grid\ActionColumn'],
            ],
        ]); ?>
        </div>
    </div>
</div>
