/* 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Funcion para validar en servidor
 * el cupo de cada sucursal
 * 
 * @param string urlControllers
 * 
 * @returns {undefined}
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2014 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 */
function validateQuotaBranch(urlController) {
	$("#div-error").html('');
    $("#div-error").hide();
    codeBranch = $("#codeBranch").val();
    nit = $("#codClient").val();
    $.ajax({url: urlController,
        type: "post",
        data: {codeBranch: codeBranch, nit: nit},
        dataType: 'json',
        success: function(data) {		
            if (typeof(data) != "undefined" && data !== null) {
                if (data.error != false) {
                    $("#div-error").html(data.msg);
                    $("#div-error").show();
                }
            }
        }});
}

/**
 * Metodo para crear mensaje de error
 * 
 * @param string msg Mensaje
 * 
 * @returns string html
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2014 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 */
function showError(msg) {
    if (msg === '' || !msg || msg === null) {
        $("#div-error").html('');
        $("#div-error").removeClass('alert alert-error in alert-block fade');
    } else {
        $("#div-error").html(msg);
        $("#div-error").addClass('alert alert-error in alert-block fade');
        $("#div-error").show();
        $('html, body').stop().animate({
            scrollTop: $("#div-error").offset().top - 50
        }, 1000);
    }
}

/**
 * Funcion para ocultar las etiquetas tr
 * @returns {undefined}
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2014 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 */
function hideTr() {
    suma = 0;
    jQuery('.amount').each(
            function() {
                val = jQuery(this).val();
                parentTd = $(this).parent();
                parentTr = parentTd.parent().attr('id');
                if (val == 0 || !this.value) {
                    $('#' + parentTr).hide();
                } else {
                    $('#' + parentTr).show();
                }
                $('#' + parentTr).removeAttr('class');
            });
}

/**
 * funcion para presentar las etiquetas TR
 * @returns {undefined}
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2014 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 */
function showTr() {
    suma = 0;
    jQuery('.amount').each(
            function() {
                val = jQuery(this).val();
                int = parseInt(val);
                parentTd = $(this).parent();
                parentTr = parentTd.parent().attr('id');
                if (int === 0 || !this.value) {
                    $('#' + parentTr).attr('class', 'error');
                }
                $('#' + parentTr).show();
            });
}

/**
 * Metodo para ocultar las tabs
 * @returns {undefined}
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2014 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 */
function hideTabs() {
    $('.ui-accordion-content').each(function() {
        var sw = 0;
        jQuery('.amount', $(this)).each(
                function() {
                    val = jQuery(this).val();
                    int = parseInt(val);
                    if (int > 0) {
                        sw = 1;
                    }
                });
        head = $(this).prev('h3');
        if (sw === 0) {
            head.hide();
            $(this).hide();
        } else {
            head.show().off().addClass('ui-state-active');
            $(this).show();
        }
    });
}

/**
 * Funcion para habilitar el boton enviar
 * @param string typeButtom
 * @returns {undefined}
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2014 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 */
function buttomSend(typeButtom, url) {
    $.ajax({url: url,
        type: "post",
        async: false,
        data: {type: typeButtom},
        success: function(data) {
            $("#buttom").html(data);
        }});
}

/**
 * Metodo para filtrar los productos 
 * 
 * @param {string} idFilter    Identificador del filtro
 * @param {string} classFilter Nombre de la clase
 * 
 * @returns {string}
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2014 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 */
function filter(idFilter, classFilter) {
//$("#" + idFilter).blur(function() {
    distractor.show();
    var filter = $('#' + idFilter).val(), count = 0;
    if (filter) {
        $("." + classFilter).each(function() {
            string = $(this).attr('id');
            stringSplit = string.split('_');
            iden = stringSplit[0];
            // If the list item does not contain the text phrase fade it out
            if ($(this).text().trim().search(new RegExp(filter, "i")) < 0) {
                $('#' + iden + '_tr').fadeOut();
                //$(this).fadeOut();
                // Show the list item if the phrase matches and increase the count by 1
            } else {
                $('#' + iden + '_tr').show();
                //$(this).show();
                count++;
            }
        });
        // Update the count
        //var numberItems = count;
        if (filter !== '') {
            $("#filter-count").html("&nbsp;<i>Registros encontrados: " + count + "</i>");
        } else {
            $("#filter-count").html("");
        }
    }
    distractor.hide();
    //});
}

/**
 * Funcion para limpiar los filtros
 * @param {type} idFilter
 * @returns {undefined}
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2014 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 */
function clearFilter(idFilter) {
    $(this).val('');
    $("#" + idFilter).val('');
}

/**
 * Funcion que permite sumar las columnas
 * @param string classDiv Clase de la columnas
 * @returns {unresolved}
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2014 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 */
function sumaColumn(classDiv) {
    suma = 0;
    jQuery('' + classDiv + '').each(
            function() {
                val = jQuery(this).html();
                valInt = val.replace(/,/gi, '');
                suma = suma + parseInt(valInt);
            });
    return suma;
}


/**
 * Metodo para realizar la sumatoria total
 *
 * @returns {undefined}
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2014 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co     
 */
function summary() {
    subUnt = sumaColumn('.sub');
    $('#total_net').html(subUnt);
    $('#total_net').number(subUnt);
    subUntIva = sumaColumn('.sub_iva');
    $('#total').html(subUntIva);
    $('#total').number(subUntIva);
    totalIva = subUntIva - subUnt;
    $('#total_iva').html(totalIva);
    $('#total_iva').number(totalIva);
}


/**
 * Metodo para adicionar los items 
 * a la tabla table-selected 
 *  
 * @param {string} id identificador-referencia
 * 
 * @returns {undefined}     
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2014 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 */
function addItem(id) {
    parentTr = $('#' + id + '_tr');
    tr = parentTr.remove();
    $("#table-selected > tbody").append(parentTr);
    $(parentTr).find(".td_hide").show();
    $('#' + id + '-accion-plus').hide();
    $('#' + id + '-accion-trash').show();
    //sortDescription('table-selected');
    countItemsSelected();
    $('.amount').focus(function() {
        $(this).val('');
        string = $(this).attr('id');
        stringSplit = string.split('_');
        iden = stringSplit[2];
        $('#' + iden + '_tr').attr('class', 'error');
        $('#' + iden + '-sub').html(0);
        $('#' + iden + '-sub-iva').html(0);
        $('#' + iden + '_sub_input_id').val(0);
    });
}


/**
 * Metodo para remover el item de la 
 * tabla table-selected
 * 
 * @param {string} id identificador-referencia
 * 
 * @returns {undefined}
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2014 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 */
function removeItem(id) {
    parentTr = $('#' + id + '_tr');
    $(parentTr).find(".td_hide").hide();
    $("#table-search > tbody").append(parentTr);
    $('#' + id + '-accion-plus').show();
    $('#' + id + '-accion-trash').hide();
    $("#table-search").find(".amount").val(0);
    sortDescription('table-search');
    countItemsSelected();
}


/**
 * Metodo para contar los 
 * items seleccionados en la tabla 
 * "table-selected"
 * 
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2014 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 */
function countItemsSelected(liquidate) {
    var countItems = 0;
    jQuery('#table-selected .amount').each(
            function() {
                if (liquidate) {
                    val = jQuery(this).val();
                    int = parseInt(val);
                    if (int > 0) {
                        countItems++;
                    }
                } else {
                    countItems++;
                }
            });
    $("#count-items-selected").html("&nbsp;<i>Items seleccionados: " + countItems + "</i>");
}

/**
 * Metodo para ordenar las tablas 
 * 
 * @param {strign} nameTable
 * 
 * @returns {undefined}
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2014 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 */
function sortDescription(nameTable) {
    var $table = $('#' + nameTable);
    var $rows = $('tbody > tr', $table);
    $rows.sort(function(a, b) {
        var keyA = $('td:eq(2)', a).text();
        var keyB = $('td:eq(2)', b).text();
        //if(jQuery($sort).hasClass('asc')){
        return (keyA > keyB) ? 1 : 0;
        //} else {
        //return (keyA < keyB) ? 1 : 0;
        //}
    });
    $.each($rows, function(index, row) {
        $table.append(row);
    });
}

/**
 * Funcion para abrir las tabs que contengan 
 * cantidades
 * @returns {undefined}
 */
function openTabs() {
    $('.ui-accordion-content').each(function() {
        var sw = 0;
        jQuery('.amount', $(this)).each(
                function() {
                    val = jQuery(this).val();
                    int = parseInt(val);
                    if (int > 0) {
                        sw = 1;
                    }
                });
        head = $(this).prev('h3');
        if (sw === 0) {
            head.hide();
            $(this).hide();
        } else {
            head.show().off().addClass('ui-state-active');
            $(this).show();
        }
    });
}


/**
 * funcion para presentar las etiquetas TR
 * @returns {undefined}
 */
function showTrRef() {
    suma = 0;
    jQuery('#table-selected .amount').each(
            function() {
                val = jQuery(this).val();
                int = parseInt(val);
                var iden;
                string = $(this).attr('id');
                stringSplit = string.split('_');
                iden = stringSplit[2];
                if (int === 0 || !this.value) {
                    $('#' + iden + '_tr').attr('class', 'error');
                }
                $('#' + iden + '_tr').show();
            });
}

/**
 * Funcion para ocultar los input vacios 
 * de las cantidades que esten
 * o en cero o vacios
 * @returns {undefined}
 */
function hideInputsEmpty(){
    jQuery('.amount').each(
            function() {
                val = jQuery(this).val();
                parentTd = $(this).parent();
                parentTr = parentTd.parent().attr('id');
                if (val == 0 || !this.value) {
                    $('#' + parentTr).find('input').attr('disabled', 'disabled');
                }                
            });
}

//FUNCIONES PARA LOS BOTONES----------------------------------------------------

function enabledForm(idForm) {
    $('#' + idForm).find('input, textarea, select').removeAttr('disabled');
    $('#buttom').find('button').attr('disabled', 'disabled');
}

function submitForm(idForm) {
    form = $('#' + idForm);
    form.submit();
}